function expe = expe_CL(Par,pts,niter)

a = Par(1);
c = Par(2);
w0 = Par(3);
K_L = Par(4);
K_T = Par(5);
g = Par(6);
A = Par(7);
Vug = Par(8);
eH = Par(9);

wsp = Par(10:13);
psp = Par(14:17);

expe0 = 10*eH;

e0L = 1e-1;
e0H = (1/(1+g))*eH -1e-6;
expeM = linspace(e0L,e0H,pts)';

iw = find(psp>0,1);
Pare = [a c w0 K_L K_T g A Vug iw wsp psp];
parfor i = 1:pts
    D(i) = DCL_e(expeM(i),Pare);
end

tol = 1e-10;
if D(1) > 0
   i1 = find(D<0, 1 );
   i2 = find(D<0, 1, 'last' );

   expe = [expe0 expe0];
   if sum(i1) > 0
        brk = 0;
        iter = 1;

        e1H = expeM(i1);
        e1L = expeM(i1-1);
        while brk == 0 && iter < niter
            e1M = (e1L + e1H)/2;
            D1M = DCL_e(e1M,Pare);
            if D1M > 0
                e1L = e1M;
            else
                e1H = e1M;
            end
            if (e1L-e1H)^2<tol;
                brk = 1;            
            end
            iter = iter+1;    
        end     
        if i2<pts
            brk = 0;
            iter = 1;

            e2L = expeM(i2);
            e2H = expeM(i2+1);
            while brk == 0 && iter < niter
                e2M = (e2L + e2H)/2;
                D2M = DCL_e(e2M,Pare);
                if D2M > 0
                    e2H = e2M;
                else
                    e2L = e2M;
                end
                if (e2L-e2H)^2<tol;
                    brk = 1;            
                end
                iter = iter+1;    
            end
            expe = [e1L e2L];
        else
            expe(1) = e1L;
        end
   end
else
   i1 = find(D>0, 1 );
   i2 = find(D>0, 1, 'last' );

   expe = [expe0 expe0];
   if sum(i1) > 0
        brk = 0;
        iter = 1;

        e1H = expeM(i1);
        e1L = expeM(i1-1);
        while brk == 0 && iter < niter
            e1M = (e1L + e1H)/2;
            D1M = DCL_e(e1M,Pare);
            if D1M > 0
                e1H = e1M;
            else
                e1L = e1M;
            end
            if (e1L-e1H)^2<tol;
                brk = 1;            
            end
            iter = iter+1;    
        end     
        if i2<pts
            brk = 0;
            iter = 1;

            e2L = expeM(i2);
            e2H = expeM(i2+1);
            while brk == 0 && iter < niter
                e2M = (e2L + e2H)/2;
                D2M = DCL_e(e2M,Pare);
                if D2M > 0
                    e2L = e2M;
                else
                    e2H = e2M;
                end
                if (e2L-e2H)^2<tol;
                    brk = 1;            
                end
                iter = iter+1;    
            end
            expe = [e1L e2L];
        else
            expe(1) = e1L;
        end
   end
end


end
