function [ProbM,pres,Dres,lMres,TMP,Gvec,Ivec,lIvec, ResM] = fPsim1n(Par,nsamp,A,l,Wsp0,Psp,avAadj,avAclose)
%
% Function that uses inferred expe to compare realized l and V under 
% (i) a no fragmentation regime (A is large) and 
% (ii) no cost K regime against the benchmark one. 
%

a    = Par(1);
c    = Par(2);
g    = Par(3);
eta_0  = Par(4);
eta_1 = Par(5);
eta_2 = Par(6);
k_L  = Par(7);
k_T  = Par(8);
b    = Par(9);
is_e = Par(10);
lambda_1 = Par(11);

Par = [a c g eta_0 eta_1 eta_2 k_L k_T b is_e];

Wsp = Wsp0*lambda_1;

[choiceM,choiceMnoK,LuM,LiM,LiMnoK,VuiM,ViM,ViMnoK,VaiM,eta] = fPsimn(Par,nsamp,A,Wsp,Psp,avAadj,avAclose);


[nr,nc] = size(choiceM);
ProbM = zeros(nr,5);

for i=1:5
    for j=1:nr
        ProbM(j,i) = length(find(choiceM(j,:) == i))/nc;
    end
end

avec = [];
luvec = [];
lvec = [];
lvecnoK = [];

Vuvec = [];
Vvec = [];
VvecnoK = [];
Vavec = [];

choicevec = [];
choicevecnoK = [];
for i = 1:nsamp
    Dvec(:,i) = exp(log(l) - log(LiM(:,i))) - 1;
    avec = [avec;A];
    luvec = [luvec;LuM(:,i)]; 
    lvec = [lvec;LiM(:,i)];
    lvecnoK = [lvecnoK;LiMnoK(:,i)];

    Vuvec = [Vuvec;VuiM(:,i)]; 
    Vvec = [Vvec;ViM(:,i)];
    VvecnoK = [VvecnoK;ViMnoK(:,i)];
    Vavec = [Vavec; VaiM(:,i)];
    choicevec = [choicevec;choiceM(:,i)];
    choicevecnoK = [choicevecnoK;choiceMnoK(:,i)];
    
end

Dres = mean(Dvec,2);
n = length(choicevec);
i1 = find(choicevec == 1);
n1 = length(i1);
i2  = find(choicevec == 2);
n2 = length(i2);
i3 = find(choicevec == 3);
n3 = length(i3);
i4 = find(choicevec == 4);
n4 = length(i4);
i5 = find(choicevec == 5);
n5 = length(i5);

pres = [n1/n n2/n n3/n n4/n n5/n];

TMP = zeros(5,5);

for i = 1:5
    for j = 1:5
        tempind = find(choicevec == i & choicevecnoK == j);
        TMP(i,j) = length(tempind);
    end
end

lMres = [mean(log(lvec(n1))) mean(log(lvec(n2))) mean(log(lvec(n3))) mean(log(lvec(n4))) mean(log(lvec(n5))) mean(log(lvec([n1;n2]))) mean(log(lvec([n3;n4;n5])))];

Gu = mean((luvec-avec>0).*(Vuvec-Vavec));
G = mean((lvec-avec>0).*(Vvec-Vavec));
GnoK = mean((lvecnoK-avec>0).*(VvecnoK-Vavec));

Iu = mean((luvec-avec>0).*(luvec-avec));
lIu = mean((luvec-avec>0).*(log(luvec./avec)));
I = mean((lvec-avec>0).*(lvec-avec));
lI = mean((lvec-avec>0).*(log(lvec./avec)));
InoK = mean((lvecnoK-avec>0).*(lvecnoK-avec));
lInoK = mean((lvecnoK-avec>0).*(log(lvecnoK./avec)));

LMm = mean(log(LiM),2);
LMsd = std(log(LiM),0,2);
VuM = mean(VuiM,2); 
VMnoK = mean(ViMnoK,2);
VM = mean(ViM,2);

ResM = [VuM VMnoK VM LMm LMsd eta];

Gvec = [Gu GnoK G];
Ivec = [Iu InoK I];
lIvec = [lIu lInoK lI]; 
end