function [ProbM,pres,Dres,lMres,TMP,Gvec,Ivec,lIvec, ResM] = fPsimac_all(Par,nsamp,d_id,l,A1,A3,A4,A6,Wsp0_1,Wsp0_3,Wsp0_4,Wsp0_6,Psp1,Psp3,Psp4,Psp6,avAadj1,avAadj3,avAadj4,avAadj6,avArel1,avArel3,avArel4,avArel6)
%
% Function that uses inferred expe to compare realized l and V under 
% (i) a no fragmentation regime (A is large) and 
% (ii) no cost K regime against the benchmark one. 
%

a_1    = Par(1);
a_3    = Par(2);
a_4    = Par(3);
a_6    = Par(4);
c_1    = Par(5);
c_3    = Par(6);
c_4    = Par(7);
c_6    = Par(8);
g      = Par(9);
eta_0  = Par(10);
eta_1  = Par(11);
eta_2 = Par(12);
k_L  = Par(13);
k_T  = Par(14);
b    = Par(15);
is_e = Par(16);
lambda = Par(17);

Par1 = [a_1 c_1 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par3 = [a_3 c_3 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par4 = [a_4 c_4 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par6 = [a_6 c_6 g eta_0 eta_1 eta_2 k_L k_T b is_e];

Wsp1 = Wsp0_1*lambda;
Wsp3 = Wsp0_3*lambda;
Wsp4 = Wsp0_4*lambda;
Wsp6 = Wsp0_6*lambda;

[choiceM1,choiceMnoK1,LuM1,LiM1,LiMnoK1,VuiM1,ViM1,ViMnoK1,VaiM1,eta1] = fPsimn(Par1,nsamp,A1,Wsp1,Psp1,avAadj1,avArel1);
[choiceM3,choiceMnoK3,LuM3,LiM3,LiMnoK3,VuiM3,ViM3,ViMnoK3,VaiM3,eta3] = fPsimn(Par3,nsamp,A3,Wsp3,Psp3,avAadj3,avArel3);
[choiceM4,choiceMnoK4,LuM4,LiM4,LiMnoK4,VuiM4,ViM4,ViMnoK4,VaiM4,eta4] = fPsimn(Par4,nsamp,A4,Wsp4,Psp4,avAadj4,avArel4);
[choiceM6,choiceMnoK6,LuM6,LiM6,LiMnoK6,VuiM6,ViM6,ViMnoK6,VaiM6,eta6] = fPsimn(Par6,nsamp,A6,Wsp6,Psp6,avAadj6,avArel6);

LiM = [LiM1;LiM3;LiM4;LiM6];
VuiM = [VuiM1;VuiM3;VuiM4;VuiM6];

ViMnoK = [ViMnoK1;ViMnoK3;ViMnoK4;ViMnoK6];
ViM = [ViM1;ViM3;ViM4;ViM6];

eta = [eta1;eta3;eta4;eta6];
choiceM = [choiceM1;choiceM3;choiceM4;choiceM6];

[nr,nc] = size(choiceM);
ProbM = zeros(nr,5);

for i=1:5
    for j=1:nr
        ProbM(j,i) = length(find(choiceM(j,:) == i))/nc;
    end
end

avec = [];
luvec = [];
lvec = [];
lvecnoK = [];

Vuvec = [];
Vvec = [];
VvecnoK = [];
Vavec = [];

choicevec = [];
choicevecnoK = [];

for i = 1:nsamp
    Dvec(:,i) = exp(log(l) - log(LiM(:,i))) - 1;
    avec = [avec;A1;A3;A4;A6];
    luvec = [luvec;LuM1(:,i);LuM3(:,i);LuM4(:,i);LuM6(:,i)]; 
    lvec = [lvec;LiM(:,i)];
    lvecnoK = [lvecnoK;LiMnoK1(:,i);LiMnoK3(:,i);LiMnoK4(:,i);LiMnoK6(:,i)];

    Vuvec = [Vuvec;VuiM(:,i)]; 
    Vvec = [Vvec;ViM(:,i)];
    VvecnoK = [VvecnoK;ViMnoK(:,i)];
    Vavec = [Vavec; VaiM1(:,i); VaiM3(:,i); VaiM4(:,i); VaiM6(:,i)];
    choicevec = [choicevec;choiceM1(:,i);choiceM3(:,i);choiceM4(:,i);choiceM6(:,i)];
    choicevecnoK = [choicevecnoK;choiceMnoK1(:,i);choiceMnoK3(:,i);choiceMnoK4(:,i);choiceMnoK6(:,i)]; 
end

Dres = mean(Dvec,2);
n = length(choicevec);
i1 = find(choicevec == 1);
n1 = length(i1);
i2  = find(choicevec == 2);
n2 = length(i2);
i3 = find(choicevec == 3);
n3 = length(i3);
i4 = find(choicevec == 4);
n4 = length(i4);
i5 = find(choicevec == 5);
n5 = length(i5);

pres = [n1/n n2/n n3/n n4/n n5/n];

TMP = zeros(5,5);

for i = 1:5
    for j = 1:5
        tempind = find(choicevec == i & choicevecnoK == j);
        TMP(i,j) = length(tempind);
    end
end

lMres = [mean(log(lvec(n1))) mean(log(lvec(n2))) mean(log(lvec(n3))) mean(log(lvec(n4))) mean(log(lvec(n5))) mean(log(lvec([n1;n2]))) mean(log(lvec([n3;n4;n5])))];

Gu = mean((luvec-avec>0).*(Vuvec-Vavec));
G = mean((lvec-avec>0).*(Vvec-Vavec));
GnoK = mean((lvecnoK-avec>0).*(VvecnoK-Vavec));

Iu = mean((luvec-avec>0).*(luvec-avec));
lIu = mean((luvec-avec>0).*(log(luvec./avec)));
I = mean((lvec-avec>0).*(lvec-avec));
lI = mean((lvec-avec>0).*(log(lvec./avec)));
InoK = mean((lvecnoK-avec>0).*(lvecnoK-avec));
lInoK = mean((lvecnoK-avec>0).*(log(lvecnoK./avec)));

LMm = mean(log(LiM),2);
LMsd = std(log(LiM),0,2);
VuM = mean(VuiM,2); 
VMnoK = mean(ViMnoK,2);
VM = mean(ViM,2);

ResM = [VuM VMnoK VM LMm LMsd eta];

Gvec = [Gu GnoK G];
Ivec = [Iu InoK I];
lIvec = [lIu lInoK lI]; 
end