function Q = fac_sil(X0,choice1,choice3,choice4,choice6,l1,l3,l4,l6,A1,A3,A4,A6,Wsp0_1,Wsp0_3,Wsp0_4,Wsp0_6,Psp1,Psp3,Psp4,Psp6,avAadj1,avAadj3,avAadj4,avAadj6,avArel1,avArel3,avArel4,avArel6,n)
% Function that returns the log-likelihood of the model Q for a given set 
% of parameters. 

Par = X2Pac(X0);

a_1    = Par(1);
a_3    = Par(2);
a_4    = Par(3);
a_6    = Par(4);
c_1    = Par(5);
c_3    = Par(6);
c_4    = Par(7);
c_6    = Par(8);
g      = Par(9);
eta_0  = Par(10);
eta_1  = Par(11);
eta_2 = Par(12);
k_L  = Par(13);
k_T  = Par(14);
b    = Par(15);
is_e = Par(16);
lambda = Par(17);

Par1 = [a_1 c_1 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par3 = [a_3 c_3 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par4 = [a_4 c_4 g eta_0 eta_1 eta_2 k_L k_T b is_e];
Par6 = [a_6 c_6 g eta_0 eta_1 eta_2 k_L k_T b is_e];

Wsp1 = Wsp0_1*lambda;
Wsp3 = Wsp0_3*lambda;
Wsp4 = Wsp0_4*lambda;
Wsp6 = Wsp0_6*lambda;

lI1 = f_I(Par1,choice1,l1,A1,Wsp1,Psp1,avAadj1,avArel1);
lI3 = f_I(Par3,choice3,l3,A3,Wsp3,Psp3,avAadj3,avArel3);
lI4 = f_I(Par4,choice4,l4,A4,Wsp4,Psp4,avAadj4,avArel4);
lI6 = f_I(Par6,choice6,l6,A6,Wsp6,Psp6,avAadj6,avArel6);

lI = [lI1;lI3;lI4;lI6];

Q = -1*sum(lI)/n;
end

