function Q = fn(X0,choice,l,A,Wsp0,Psp,avAadj,avAclose)
% Function that returns the log-likelihood of the model Q parfor a given set 
% of parameters. 

Par = X2Pn(X0);

a    = Par(1);
c    = Par(2);
g    = Par(3);
eta_0  = Par(4);
eta_1 = Par(5);
eta_2 = Par(6);
k_L  = Par(7);
k_T  = Par(8);
b    = Par(9);
is_e = Par(10);
lambda = Par(11);

disp(fprintf(' a = %1.5f  | c = %1.5f | g =  %1.5f | eta_0 = %1.5f  | eta_1 = %1.5f  | eta_2 = %1.5f  | k_L = %1.5f | k_T = %1.5f | b = %1.5f  | is = %1.5f | l = %1.5f \n',Par));

leta = eta_0 + eta_1*log(avAadj) + eta_2*avAclose;
eta = 1./(1+exp(leta));

K_L = k_L + b*log(avAadj);
K_T = k_T + b*log(avAadj);

Wsp = Wsp0*lambda;

n = length(l);

lI = -20*ones(n,1);

w0 = (c/(1-a))^(1/a);
delta = ((1-eta*(1-a))/a).*eta.^(1/a-1);

Kg = (1+g)^((a-1)/a);

EWa = sum(Psp.*(Wsp.^a),2);

Lu = (1/w0)*EWa.^(1/a);
expeH = (Lu./A).^a;
expeHL = (1/(1+g))*expeH;

Vu = a*w0^(a-1)*EWa.^(1/a);
Vug = Kg*Vu;

iSC = find(choice == 0 & l==A);
iU = find(choice == 0 & l<A);
iT = find(choice>0);
nSC = length(iSC);
nT = length(iT);

C_1 = (Kg-delta(iT)).*Vu(iT);

C_2 = c*g*A(iT);

ikldT = find(Kg >= delta(iT));
iksdT = find(Kg < delta(iT));

zmin = (((1-a)*C_1)./(a*C_2)).^a;
zminval = (C_1/a).^a.*(C_2/(1-a)).^(1-a) - K_L(iT) + K_T(iT);

expeLA0 = expeH(iT)/(1+g);

expeLAK = zeros(nT,1);
expePAK = zeros(nT,1);
expeCAK = zeros(nT,1);

niter = 20;
pts = 100;
x0 = .5;

delta_temp = delta(iT);
Vug_temp = Vug(iT);
Vu_temp = Vu(iT);
EWa_temp = EWa(iT);
K_L_temp = K_L(iT);
K_T_temp = K_T(iT);
Psp_temp = Psp(iT,:);
Wsp_temp = Wsp(iT,:);
A_temp = A(iT);
expeH_temp = expeH(iT);

parfor j = 1:nT
    ParL = [a c g Vug_temp(j) EWa_temp(j) K_L_temp(j) A_temp(j) expeLA0(j)];
    f = @(x)expe_LA(x,ParL);
    xLA = fzero(f,x0);
    expeLAK(j,1) = expeLA0(j)*exp(xLA)/(1+exp(xLA));
    ParP = [a c delta_temp(j) Vu_temp(j) EWa_temp(j) K_T_temp(j) A_temp(j) expeH_temp(j)];
    f = @(x)expe_PA(x,ParP);
    xPA = fzero(f,xLA);
    expePAK(j,1) = expeH_temp(j)*exp(xPA)/(1+exp(xPA));
    
    iw = find(Psp_temp(j,:)>0,1);
    l0H = Wsp_temp(j,iw)/w0;
    ParCA = [a c w0 K_T_temp(j) A_temp(j) EWa_temp(j) expeH_temp(j) l0H Wsp_temp(j,:) Psp_temp(j,:)];
    expeCAK(j,1) = expe_CA(ParCA,niter);
end

expeCAK(expeCAK==expeH(iT)-1e-6) = -1;
expe_AK = max([expeLAK expePAK expeCAK],[],2);

% SU %
%%%%%%

et = log(Lu(iU)) - log(l(iU));
J = 1./l(iU);
S = a*is_e*J.*normpdf(a*is_e*et);

lI(iU) = log(S);

% SC %
%%%%%%

expeLA = zeros(nSC,1);
expePA = zeros(nSC,1);
expeCA = zeros(nSC,1);

delta_temp = delta(iSC);
Vu_temp = Vu(iSC);
Vug_temp = Vug(iSC);
EWa_temp = EWa(iSC);
K_L_temp = K_L(iSC);
K_T_temp = K_T(iSC);
Psp_temp = Psp(iSC,:);
Wsp_temp = Wsp(iSC,:);
A_temp = A(iSC);
expeH_temp = expeH(iSC);

parfor j = 1:nSC
    ParL = [a c g Vug_temp(j) EWa_temp(j) K_L_temp(j) A_temp(j) expeH_temp(j)/(1+g)];
    f = @(x)expe_LA(x,ParL);
    xLA = fzero(f,x0);
    expeLA(j,1) = (expeH_temp(j)/(1+g))*exp(xLA)/(1+exp(xLA));
    ParP = [a c delta_temp(j) Vu_temp(j) EWa_temp(j) K_T_temp(j) A_temp(j) expeH_temp(j)];
    f = @(x)expe_PA(x,ParP);
    xPA = fzero(f,xLA);
    expePA(j,1) = expeH_temp(j)*exp(xPA)/(1+exp(xPA));
    
    iw = find(Psp_temp(j,:)>0,1);
    l0H = Wsp_temp(j,iw)/w0;
    ParCA = [a c w0 K_T_temp(j) A_temp(j) EWa_temp(j) expeH_temp(j) l0H Wsp_temp(j,:) Psp_temp(j,:)];
    expeCA(j,1) = expe_CA(ParCA,niter);
end

expe_H = expeH(iSC);

sumP = sum(Psp(iSC,:),2);
ip0 = find(sumP < .98);

inC = find(expeCA==expe_H-1e-6);

%Identifying obs with p0>0. No need to worry about choice since ci = S always;
%When using the holdout sample, ip0 = [] as there are no obs with
%pr(W=0)>0;

expeCA([ip0;inC]) = -1;
expe_L = max([expeLA expePA expeCA],[],2);

lI(iSC) = log(normcdf(is_e*log(expe_H)) - normcdf(is_e*log(expe_L)));

% L %
%%%%%

iLkldT = find(choice(iT(ikldT))==1);

if sum(iLkldT)>0
    iLcr0 = find(zminval(iLkldT)>0);
    nLcr0 = length(iLcr0);

    if nLcr0 > 0
        expeLA = expeLAK(ikldT(iLkldT(iLcr0)));
        expeCA = expeCAK(ikldT(iLkldT(iLcr0)));
        expeCL = zeros(nLcr0,2);

    Vug_temp = Vug(iT(ikldT(iLkldT(iLcr0))));
    K_L_temp = K_L(iT(ikldT(iLkldT(iLcr0))));
    K_T_temp = K_T(iT(ikldT(iLkldT(iLcr0))));
    Psp_temp = Psp(iT(ikldT(iLkldT(iLcr0))),:);
    Wsp_temp = Wsp(iT(ikldT(iLkldT(iLcr0))),:);
    A_temp = A(iT(ikldT(iLkldT(iLcr0))));
    expeH_temp = expeH(iT(ikldT(iLkldT(iLcr0))));

        parfor j = 1:nLcr0
            ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCL(j,:) = expe_CL(ParCL,pts,niter);
        end

        PR = 1e-6*ones(nLcr0,1);
        
        iA1 = find((expeCA > expeLA) + (expeCL(:,2) > expeLA) + (expeCL(:,1) < expeCA) == 3);
        iA2 = find((expeCA < expeLA) + (expeCL(:,1) > expeLA) == 2);
        iA3 = find((expeCA < expeLA) + (expeCL(:,2) < expeLA) == 2);
        iA5 = find((expeCA < expeLA) + (expeCL(:,1) < expeCA) == 2);
        iA6 = find((expeCA > expeLA) + (expeCL(:,2) < expeLA) == 2);

        expe_H = zeros(nLcr0,1);

        expe_H([iA1;iA3]) = expeCL([iA1;iA3],1);
        expe_H([iA2;iA5]) = expeLA([iA2;iA5]);
        expe_H(iA6) = expeCL(iA6,2);
  
        PR([iA1;iA2;iA3]) = normcdf(is_e*log(expe_H([iA1;iA2;iA3]))); 
        if ~isempty(iA3)
            PR(iA3) = PR(iA3) +  normcdf(is_e*log(expeLA(iA3))) - normcdf(is_e*log(expeCL(iA3,2)));
        end
        if ~isempty([iA5;iA6])
            PR([iA5;iA6]) = normcdf(is_e*log(expe_H([iA5;iA6]))) - normcdf(is_e*log(expeCL([iA5;iA6],1)));
        end
        
        lI(iT(ikldT(iLkldT(iLcr0)))) = log(PR);

        et = log((1/(1+g))^(1/a)*Lu(iT(ikldT(iLkldT(iLcr0))))) - log(l(iT(ikldT(iLkldT(iLcr0)))) + A(iT(ikldT(iLkldT(iLcr0)))));
        J = 1./(l(iT(ikldT(iLkldT(iLcr0)))) + A(iT(ikldT(iLkldT(iLcr0)))));
        S = a*is_e*J.*normpdf(a*is_e*et);
        PR0 = max(normcdf(is_e*log(expe_AK(ikldT(iLkldT(iLcr0))))),1e-5); 
        lI(iT(ikldT(iLkldT(iLcr0)))) = lI(iT(ikldT(iLkldT(iLcr0)))) + log(S) - log(PR0);   
    end

    iLcr2 = find(zminval(iLkldT)<0);
    nLcr2 = length(iLcr2);
    if nLcr2 > 0
         expeLA = expeLAK(ikldT(iLkldT(iLcr2)));
         expeCA = expeCAK(ikldT(iLkldT(iLcr2)));
         expePA = expePAK(ikldT(iLkldT(iLcr2)));
         expeCL = zeros(nLcr2,2);
         expeCP = zeros(nLcr2,2);
         expePL = zeros(nLcr2,2);
         
         delta_temp = delta(iT(ikldT(iLkldT(iLcr2))));
         Vug_temp = Vug(iT(ikldT(iLkldT(iLcr2))));
         Vu_temp = Vu(iT(ikldT(iLkldT(iLcr2))));
         K_L_temp = K_L(iT(ikldT(iLkldT(iLcr2))));
         K_T_temp = K_T(iT(ikldT(iLkldT(iLcr2))));
         Psp_temp = Psp(iT(ikldT(iLkldT(iLcr2))),:);
         Wsp_temp = Wsp(iT(ikldT(iLkldT(iLcr2))),:);
         A_temp = A(iT(ikldT(iLkldT(iLcr2))));
         expeH_temp = expeH(iT(ikldT(iLkldT(iLcr2))));
         C_1_temp = C_1(ikldT(iLkldT(iLcr2)));
         C_2_temp = C_2(ikldT(iLkldT(iLcr2)));
         
         zmin_temp = zmin(ikldT(iLkldT(iLcr2)));

         parfor j = 1:nLcr2
            ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCL(j,:) = expe_CL(ParCL,pts,niter);
            ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) zmin_temp(j) expeH_temp(j)];
            expePL(j,:) = expe_PLr2(ParPL);
            ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCP(j,:) = expe_CP(ParCP,pts,niter);
         end
            
        iD1 = find((expeCL(:,1) < expePL(:,1)) + (expeCA > expeLA) + (expeCA > expePA) + (expeCL(:,2) > expeCA) + (expeCP(:,2) > expeCA) == 5);    
        iD2 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD3 = find((expePL(:,2) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD4 = find((expePL(:,2) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) > expeLA) + (expeLA > expeCA) + (expeLA > expePA) == 5);
        iD5 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expeCL(:,2) > expePL(:,2)) + (expeCL(:,2) < expeCA) + (expeCA < expeLA) + (expePA < expeLA) == 6); 
        iD5 = [iD5; find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,2) < expeCA) + (expeCA < expeLA) + (expeLA < expePL(:,1)) + (expePA < expeLA) == 5)];
        iD6 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 8);  
        iD7 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,2)) + (expePL(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD8 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD10 = find((expePL(:,2) < expeCL(:,1)) + (expeCL(:,1) < expeCA) + (expeCA < expeLA) + (expePA < expeLA) == 4); 
        iD10 = [iD10; find((expeCL(:,1) < expeCP(:,1)) + (expePA < expeLA) + (expeCA < expeLA) + (expeLA < expePL(:,1)) + (expeLA > expeCL(:,2)) == 5)];
        iD11 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,2)) + (expePL(:,2) < expePA) + (expePA < expeLA) + (expeCA < expePA) == 6);  
        iD12 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,2)) + (expeCL(:,2) > expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 6);  
        iD13 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,1) < expeCL(:,2)) + (expeCL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expePL(:,2)) + (expeCP(:,2) < expeCA) + (expeLA < expeCA) + (expePA < expeCA) == 8);  
        iD14 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeLA < expeCA) + (expePA < expeCA) == 7);  
        iD16 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePL(:,2)) + (expePL(:,2) < expeCL(:,1)) + (expeCL(:,1) < expeCA) + (expeCA < expeLA) + (expePA < expeCA) == 6);  

        iE3 = find((expePL(:,1) < expePA) + (expePL(:,1) < expeCL(:,1)) + (expeCP(:,1) > expePA) + (expeCA < expePA) + (expeLA < expePA) == 5); 
        iE4 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,2)) == 6);  
        iE7 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
        iF2 = find((expeCA < expeLA) + (expePA < expeLA) + (expeLA < expePL(:,1)) + (expeLA < expeCL(:,1)) + (expeLA < expeCP(:,1)) == 5);

        iDN1 = find((expeCL(:,2) < expePL(:,1)) +  (expePL(:,1) < expeLA) + (expePA > expeLA) == 3);
        iDN2 = find((expePL(:,1) < expeCP(:,1)) +  (expeCP(:,2) < expeCA) + (expeCA < expePA) == 3);
        iDN3 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
        iDN4 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeLA) + (expeLA < expePL(:,1)) + (expeLA > expePA) + (expeLA > expeCA) == 5);  
        iDN5 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCA) + (expeCA > expeLA) + (expeCA > expePA) == 4);
        iDN6 = find((expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,1)) == 5);  
        iDN7 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
               
        expe_H = expePL(:,1);
        expe_L = expeCL(:,1);

        expe_H([iD1;iD5;iD6;iDN1;iDN6;iE4]) = expeCL([iD1;iD5;iD6;iDN1;iDN6;iE4],1);
        expe_H([iD10;iD11;iD16;iDN4;iF2]) = expeLA([iD10;iD11;iD16;iDN4;iF2]);
        expe_H([iDN3;iDN5;iDN7]) = expeCL([iDN3;iDN5;iDN7],2);

        expe_L(iD11) = expePL(iD11,2);
        
        PR = 1e-6*ones(nLcr2,1);

        iR = [iD1;iD2;iD3;iD4;iD5;iD6;iD7;iD8;iDN1;iDN2;iDN6;iE3;iE4;iF2];
        if ~isempty(iR)
        PR(iR) = normcdf(is_e*log(expe_H(iR)));
        end
        iR = [iD10;iD11;iD12;iD13;iD14;iD16;iDN3;iDN4;iDN5;iDN7;iE7];
        if ~isempty(iR)
        PR(iR) = (normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expe_L(iR)))); 
        end
        iR = [iD4;iD6;iD8];
        if ~isempty(iR)
            PR(iR) = PR(iR) + normcdf(is_e*log(expeLA(iR))) - normcdf(is_e*log(expePL(iR,2)));  
        end
        if ~isempty(iD12)
            PR(iD12) = PR(iD12) + normcdf(is_e*log(expeLA(iD12))) - normcdf(is_e*log(expePL(iD12,2)));  
        end
        
        iR = [iD5;iD7];
        if ~isempty(iR)
            PR(iR) = PR(iR) + normcdf(is_e*log(expeLA(iR))) - normcdf(is_e*log(expeCL(iR,2)));
        end
        if ~isempty(iD3)
            PR(iD3) = PR(iD3) + normcdf(is_e*log(expeCL(iD3,1))) - normcdf(is_e*log(expePL(iD3,2)));
        end
        if ~isempty(iD14)
            PR(iD14) = PR(iD14) + normcdf(is_e*log(expeCL(iD14,2))) - normcdf(is_e*log(expePL(iD14,2)));
        end
        if ~isempty(iDN1)
            PR(iDN1) = PR(iDN1) + normcdf(is_e*log(expePL(iDN1,1))) - normcdf(is_e*log(expeCL(iDN1,2)));
        end
        
        lI(iT(ikldT(iLkldT(iLcr2)))) = log(PR);    
        
        et = log((1/(1+g))^(1/a)*Lu(iT(ikldT(iLkldT(iLcr2))))) - log(l(iT(ikldT(iLkldT(iLcr2)))) + A(iT(ikldT(iLkldT(iLcr2)))));
        J = 1./(l(iT(ikldT(iLkldT(iLcr2)))) + A(iT(ikldT(iLkldT(iLcr2)))));
        S = a*is_e*J.*normpdf(a*is_e*et);
        PR0 = max(normcdf(is_e*log(expe_AK(ikldT(iLkldT(iLcr2))))),1e-5); 
        lI(iT(ikldT(iLkldT(iLcr2)))) = lI(iT(ikldT(iLkldT(iLcr2)))) + log(S) - log(PR0);   
    end
end

iLksdT = find(choice(iT(iksdT))==1);

if sum(iLksdT)>0    
    nLksd = length(iLksdT);
    expeLA = expeLAK(iksdT(iLksdT));
    expePA = expePAK(iksdT(iLksdT));
    expeCA = expeCAK(iksdT(iLksdT));
    expeCL = zeros(nLksd,2);
    expeCP = zeros(nLksd,2);
    expeHLc = expeHL(iT(iksdT(iLksdT)),1);
    expeHc = expeH(iT(iksdT(iLksdT)),1);
    expePL = zeros(nLksd,1);
    
    delta_temp = delta(iT(iksdT(iLksdT)));
    Vug_temp = Vug(iT(iksdT(iLksdT)));
    Vu_temp = Vu(iT(iksdT(iLksdT)));
    K_L_temp = K_L(iT(iksdT(iLksdT)));
    K_T_temp = K_T(iT(iksdT(iLksdT)));
    Psp_temp = Psp(iT(iksdT(iLksdT)),:);
    Wsp_temp = Wsp(iT(iksdT(iLksdT)),:);
    A_temp = A(iT(iksdT(iLksdT)));
    expeH_temp = expeH(iT(iksdT(iLksdT)));
    C_1_temp = C_1(iksdT(iLksdT));
    C_2_temp = C_2(iksdT(iLksdT));

    parfor j = 1:nLksd
        ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCL(j,:) = expe_CL(ParCL,pts,niter);
        ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCP(j,:) = expe_CP(ParCP,pts,niter);    
        ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) expeH_temp(j)];
        expePL(j,1) = expe_PLr1(ParPL);
    end;

    iB2 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,1) > expeCP(:,1)) + (expeCL(:,1) < expeCA) + (expeLA < expeCA) + (expeCL(:,1) < expeHLc) == 6);
    iB3 = find((expeLA > expePA) + (expeCP(:,1) > expePL) + ((expeCL(:,1) > expeLA) | (expeCL(:,1) < expePL(:,1))) + ((expeLA > expeCA) | (expeCA == expeHc-1e-6)) == 4);
    iB4 = find((expeLA > expePA) + ((expeCL(:,2).*(expeCL(:,2)<5*expeHc) > expePL) | (expeCL(:,1).*(expeCL(:,2)>5*expeHc) > expePL)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA < expeLA) == 6);    
    iB5 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeLA > expeCA) == 3);
    iB6 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) == 4);

    iB8 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCP(:,1) > expeCL(:,1)) + (expeCL(:,1) < expeLA) + (expeLA > expeCA) == 5);
    iB9 = find((expeLA > expePA) + (expeCL(:,1) < expePL) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCP(:,1) < expeCL(:,1)) + (expeLA > expeCA) == 6);
    iB10 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeCL(:,1) > expePL) + (expeCA < expeLA) == 4);    
    iB11 = find((expeLA > expePA) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCL(:,2) < expeCA) + (expeCA > expeLA) == 5);
    iB12 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,2) < expeLA) + (expeCL(:,1) < expeCP(:,1)) + (expeCA > expeLA) == 5);
   
    PR = 1e-6*ones(nLksd,1);
    expe_H = expeLA;
    expe_L = expePL;

    expe_H([iB2;iB6]) = expeCL([iB2;iB6],1);
    expe_H([iB11;iB12]) = expeCL([iB11;iB12],2);
    
    if ~isempty(iB4)
    expe_L(iB4) = (expeCL(iB4,2)>expeLA(iB4)).*expeCL(iB4,1) + (expeCL(iB4,2)<expeLA(iB4)).*expeCL(iB4,2);
    end
    expe_L([iB8;iB10;iB12]) = expeCL([iB8;iB10;iB12],1);
   
    iR = [iB2;iB3;iB4;iB5;iB6;iB8;iB9;iB10;iB11;iB12];
    PR(iR) = (normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expe_L(iR)))); 
    
    if ~isempty(iB6)
        PR(iB6) = PR(iB6) + normcdf(is_e*log(expeLA(iB6))) - normcdf(is_e*log(expeCL(iB6,2)));
    end
    lI(iT(iksdT(iLksdT))) = log(PR);  
     
    et = log((1/(1+g))^(1/a)*Lu(iT(iksdT(iLksdT)))) - log(l(iT(iksdT(iLksdT))) + A(iT(iksdT(iLksdT))));
    J = 1./(l(iT(iksdT(iLksdT))) + A(iT(iksdT(iLksdT))));
    S = a*is_e*J.*normpdf(a*is_e*et);
    PR0 = max(normcdf(is_e*log(expe_AK(iksdT(iLksdT)))),1e-5);   
    lI(iT(iksdT(iLksdT))) = lI(iT(iksdT(iLksdT))) + log(S) - log(PR0);        
end;

% P %
%%%%%

iPkldT = find(choice(iT(ikldT))==2);

if sum(iPkldT)>0
    iPcr0 = find(zminval(iPkldT)>=0);
    nPcr0 = length(iPcr0);
    if nPcr0 > 0
        lI(iT(ikldT(iPkldT(iPcr0)))) = log(1e-6);
    end
    
    iPcr2 = find(zminval(iPkldT)<0);
    nPcr2 = length(iPcr2);
    if nPcr2 > 0
         expeLA = expeLAK(ikldT(iPkldT(iPcr2)));
         expeCA = expeCAK(ikldT(iPkldT(iPcr2)));
         expePA = expePAK(ikldT(iPkldT(iPcr2)));
         expeCL = zeros(nPcr2,2);
         expeCP = zeros(nPcr2,2);
         expePL = zeros(nPcr2,2);
         
         delta_temp = delta(iT(ikldT(iPkldT(iPcr2))));
         Vug_temp = Vug(iT(ikldT(iPkldT(iPcr2))));
         Vu_temp = Vu(iT(ikldT(iPkldT(iPcr2))));
         K_L_temp = K_L(iT(ikldT(iPkldT(iPcr2))));
         K_T_temp = K_T(iT(ikldT(iPkldT(iPcr2))));
         Psp_temp = Psp(iT(ikldT(iPkldT(iPcr2))),:);
         Wsp_temp = Wsp(iT(ikldT(iPkldT(iPcr2))),:);
         A_temp = A(iT(ikldT(iPkldT(iPcr2))));
         expeH_temp = expeH(iT(ikldT(iPkldT(iPcr2))));
         C_1_temp = C_1(ikldT(iPkldT(iPcr2)));
         C_2_temp = C_2(ikldT(iPkldT(iPcr2)));
         zmin_temp = zmin(ikldT(iPkldT(iPcr2)));
        
         parfor j = 1:nPcr2
            ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCL(j,:) = expe_CL(ParCL,pts,niter);
            ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) zmin_temp(j) expeH_temp(j)];
            expePL(j,:) = expe_PLr2(ParPL);
            ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCP(j,:) = expe_CP(ParCP,pts,niter);
         end
         
        iD2 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD3 = find((expePL(:,2) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD4 = find((expePL(:,2) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) > expeLA) + (expeLA > expeCA) + (expeLA > expePA) == 5);
        iD6 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 8);  
        iD7 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,2)) + (expePL(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD8 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD11 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,2)) + (expePL(:,2) < expePA) + (expePA < expeLA) + (expeCA < expePA) == 6);  
        iD12 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,2)) + (expeCL(:,2) > expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 6);  
        iD13 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,1) < expeCL(:,2)) + (expeCL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expePL(:,2)) + (expeCP(:,2) < expeCA) + (expeLA < expeCA) + (expePA < expeCA) == 8);  
        iD14 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeLA < expeCA) + (expePA < expeCA) == 7);  
        iD15 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePL(:,2)) + (expeCL(:,1) > expeCA) + (expeCP(:,2) < expePA) + (expeLA < expeCA) + (expePA < expeCA) + (expeCP(:,2) < expeCA) == 6);  
        iD16 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePL(:,2)) + (expePL(:,2) < expeCL(:,1)) + (expeCL(:,1) < expeCA) + (expeCA < expeLA) + (expePA < expeCA) == 6);  

        iE3 = find((expePL(:,1) < expePA) +  (expeCP(:,1) > expePA) + (expeCA < expePA) + (expeLA < expePA) == 4);   
        iE4 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,2)) == 6);  
        iE6 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expePA < expePL(:,2)) + (expeLA < expePA) + (expeCA < expePA) == 5);  
        iE7 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
           
        iDN1 = find((expeCL(:,2) < expePL(:,1)) +  (expePL(:,1) < expeLA) + (expePA > expeLA) == 3);
        iDN2 = find((expePL(:,1) < expeCP(:,1)) +  (expeCP(:,2) < expeCA) + (expeCA < expePA) == 3);
        iDN3 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
        iDN6 = find((expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,1)) == 5);  
        iDN7 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePA) + (expeCA > expeLA) + (expeCA > expePA) == 5);

        expe_H = expePL(:,2);
        expe_L = expePL(:,1);

        expe_H([iD2;iD7;iD8;iDN2]) = expeCP([iD2;iD7;iD8;iDN2],1);
        expe_H([iD13;iD15;iD16;iDN6;iDN7]) = expeCP([iD13;iD15;iD16;iDN6;iDN7],2);
        expe_H([iE3;iE4;iE6;iE7;iDN1;iDN3]) = expePA([iE3;iE4;iE6;iE7;iDN1;iDN3]);
    
        expe_L([iD6;iD11;iD15;iD16;iE6;iDN3;iDN6;iDN7]) = expeCP([iD6;iD11;iD15;iD16;iE6;iDN3;iDN6;iDN7],1);
        expe_L(iE4) = expeCP(iE4,2);
        
        PR = 1e-6*ones(nPcr2,1);
        
        iR = [iD2;iD3;iD4;iD6;iD7;iD8;iD11;iD12;iD13;iD14;iD15;iE3;iE4;iE6;iE7;iDN1;iDN2;iDN3;iDN6;iDN7];
        PR(iR) = (normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expe_L(iR))));

        if ~isempty(iD8)
            PR(iD8) = PR(iD8) + normcdf(is_e*log(expePL(iD8,2))) - normcdf(is_e*log(expeCP(iD8,2)));
        end
        if ~isempty(iDN2)
            PR(iDN2) = PR(iDN2) + normcdf(is_e*log(expePA(iDN2))) - normcdf(is_e*log(expeCP(iDN2,2)));
        end
        
        lI(iT(ikldT(iPkldT(iPcr2)))) = log(PR);   
        
        et = log((eta(iT(ikldT(iPkldT(iPcr2)))).^(1/a)).*Lu(iT(ikldT(iPkldT(iPcr2))))) - log(l(iT(ikldT(iPkldT(iPcr2)))) + A(iT(ikldT(iPkldT(iPcr2)))));
        J = 1./(l(iT(ikldT(iPkldT(iPcr2)))) + A(iT(ikldT(iPkldT(iPcr2)))));
        S = a*is_e*J.*normpdf(a*is_e*et);
        PR0 = max(normcdf(is_e*log(expe_AK(ikldT(iPkldT(iPcr2))))),1e-5); 
        lI(iT(ikldT(iPkldT(iPcr2)))) = lI(iT(ikldT(iPkldT(iPcr2)))) + log(S) - log(PR0);                       
    end
end

iPksdT = find(choice(iT(iksdT))==2);

if sum(iPksdT)>0    
    nPksd = length(iPksdT);
    expeLA = expeLAK(iksdT(iPksdT));
    expePA = expePAK(iksdT(iPksdT));
    expeCA = expeCAK(iksdT(iPksdT));
    expeCL = zeros(nPksd,2);
    expeCP = zeros(nPksd,2);
    expeHLc = expeHL(iT(iksdT(iPksdT)),1);
    expeHc = expeH(iT(iksdT(iPksdT)),1);
    expePL = zeros(nPksd,1);
    
    delta_temp = delta(iT(iksdT(iPksdT)));
    Vug_temp = Vug(iT(iksdT(iPksdT)));
    Vu_temp = Vu(iT(iksdT(iPksdT)));
    K_L_temp = K_L(iT(iksdT(iPksdT)));
    K_T_temp = K_T(iT(iksdT(iPksdT)));
    Psp_temp = Psp(iT(iksdT(iPksdT)),:);
    Wsp_temp = Wsp(iT(iksdT(iPksdT)),:);
    A_temp = A(iT(iksdT(iPksdT)));
    expeH_temp = expeH(iT(iksdT(iPksdT)));
    C_1_temp = C_1(iksdT(iPksdT));
    C_2_temp = C_2(iksdT(iPksdT));
    
    parfor j = 1:nPksd
        ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCL(j,:) = expe_CL(ParCL,pts,niter);
    
        ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCP(j,:) = expe_CP(ParCP,pts,niter);    
        ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) expeH_temp(j)];
        expePL(j,1) = expe_PLr1(ParPL);

    end

    expe_H = expePL;
    PR = 1e-6*ones(nPksd,1);

    iB1 = find((expeLA > expePA) + (expeCP(:,1) < expePL) + (expeCL(:,2) > expeCA) + (expeLA < expeCA) == 4);
    iB2 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,1) > expeCP(:,1)) + (expeCL(:,1) < expeCA) + (expeLA < expeCA) + (expeCL(:,1) < expeHLc) == 6);
    iB3 = find((expeLA > expePA) + (expeCP(:,1) > expePL) + ((expeCL(:,1) > expeLA) | (expeCL(:,1) < expePL(:,1))) + ((expeLA > expeCA) | (expeCA == expeHc-1e-6)) == 4);
    iB4 = find((expeLA > expePA) + ((expeCL(:,2).*(expeCL(:,2)<5*expeHc) > expePL) | (expeCL(:,1).*(expeCL(:,2)>5*expeHc) > expePL)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA < expeLA) == 6);    
    iB5 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeLA > expeCA) == 3);
    iB6 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) == 4);

    iB9 = find((expeLA > expePA) + (expeCL(:,1) < expePL) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCP(:,1) < expeCL(:,1)) + (expeLA > expeCA) == 6);
    iB10 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeCL(:,1) > expePL) + (expeCA < expeLA) == 4);    
    iB11 = find((expeLA > expePA) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCL(:,2) < expeCA) + (expeCA > expeLA) == 5);
    
    iC1 = find((expeLA < expePA) + (expeCP(:,1) < expePA) + (expeCP(:,2) > expePA) + (expePA < expeCA) == 4);
    R = zeros(nPksd,9);
    R(iB1,1) = 1; R(iB2,2) = 1; R(iB3,3) = 1; R(iB4,4) = 1; R(iB5,5) = 1; R(iB6,6) = 1;
    R(iB9,7) = 1; R(iB10,8) = 1; R(iB11,9) = 1; 
    sR = sum(R,2);
    iC1 = [iC1;find((sR==0) + (expeCP(:,1) < expePA) + (expeCP(:,2) < expePA) + (expePA < expeCA) == 4)];

    iC2 = find((expeLA < expePA) + (expeCP(:,1) > expePA) + (expePA > expeCA) == 3);
    iC3 = find((expeLA < expePA) + (expeCP(:,2) < expePA) + (expePA > expeCA) == 3);
    
    iC5 = find((expeLA < expePA) + (expeCP(:,1) < expeCA) + (expeCP(:,2) > expePA) + (expeCA < expePA) == 4);
    iC6 = find((expeLA < expePA) + (expeCP(:,1) < expeCL(:,1)) + (expeCP(:,2) < expePA) + (expePA < expeCA) == 4);
    
    expe_H([iB1;iB4;iB5;iC1;iC3]) = expeCP([iB1;iB4;iB5;iC1;iC3],1);
    expe_H([iB10;iC6]) = expeCP([iB10;iC6],2);
    expe_H([iC2;iC5]) = expePA([iC2;iC5]);
   
    iR = [iB1;iB2;iB3;iB4;iB5;iB6;iC1;iC2;iC3];
    PR(iR) = normcdf(is_e*log(expe_H(iR)));

    iR = [iB9;iB10;iB11;iC5;iC6];
    if ~isempty(iR)    
        PR(iR) = normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expeCP(iR,1)));
    end
    if ~isempty(iB5)    
        PR(iB5) = PR(iB5) + normcdf(is_e*log(expePL(iB5))) - normcdf(is_e*log(expeCP(iB5,2)));
    end
    if ~isempty(iC3)
        PR(iC3) = PR(iC3) + normcdf(is_e*log(expePA(iC3))) - normcdf(is_e*log(expeCP(iC3,2)));
    end
    lI(iT(iksdT(iPksdT))) = log(PR);
    
    et = log((eta(iT(iksdT(iPksdT))).^(1/a)).*Lu(iT(iksdT(iPksdT)))) - log(l(iT(iksdT(iPksdT))) + A(iT(iksdT(iPksdT))));
    J = 1./(l(iT(iksdT(iPksdT))) + A(iT(iksdT(iPksdT))));
    S = sum(a*is_e*J.*normpdf(a*is_e*et),2);
    PR0 = max(normcdf(is_e*log(expe_AK(iksdT(iPksdT)))),1e-5);     
    lI(iT(iksdT(iPksdT))) = lI(iT(iksdT(iPksdT))) + log(S) - log(PR0);   
end;

% C %
%%%%%
x0L = 1e-12;

iCkldT = find(choice(iT(ikldT))==3);

if sum(iCkldT)>0
    iCcr0 = find(zminval(iCkldT)>0);
    nCcr0 = length(iCcr0);

    if nCcr0 > 0
        expeLA = expeLAK(ikldT(iCkldT(iCcr0)));
        expeCA = expeCAK(ikldT(iCkldT(iCcr0)));
        expeCL = zeros(nCcr0,2);
        
        Vug_temp = Vug(iT(ikldT(iCkldT(iCcr0))));
        K_L_temp = K_L(iT(ikldT(iCkldT(iCcr0))));
        K_T_temp = K_T(iT(ikldT(iCkldT(iCcr0))));
        Psp_temp = Psp(iT(ikldT(iCkldT(iCcr0))),:);
        Wsp_temp = Wsp(iT(ikldT(iCkldT(iCcr0))),:);
        A_temp = A(iT(ikldT(iCkldT(iCcr0))));

        expeH_temp = expeH(iT(ikldT(iCkldT(iCcr0))));        

       parfor j = 1:nCcr0
            ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCL(j,:) = expe_CL(ParCL,pts,niter);
       end

       iA1 = find((expeCA > expeLA) + (expeCL(:,2) > expeLA) + (expeCL(:,1) < expeCA) == 3);
       iA3 = find((expeCA < expeLA) + (expeCL(:,2) < expeLA) == 2);
       iA4 = find((expeCA > expeLA) + (expeCL(:,1) > expeCA) == 2);
       iA5 = find((expeCA < expeLA) + (expeCL(:,1) < expeCA) == 2);
       iA6 = find((expeCA > expeLA) + (expeCL(:,2) < expeLA) == 2);

       expe_H = expeCA;
       expe_H(iA3) = expeCL(iA3,2);
       expe_H([iA5;iA6]) = expeCL([iA5;iA6],1);
               
       PR = 1e-6*ones(nCcr0,1);
       iR = [iA1;iA3];
       if ~isempty(iR)
           PR(iR)= normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expeCL(iR,1)));
       end
       iR = [iA4;iA5;iA6];
       if ~isempty(iR)
            PR(iR)= normcdf(is_e*log(expe_H(iR)));
       end
       if ~isempty(iA6)
           PR(iA6) = PR(iA6) + normcdf(is_e*log(expeCA(iA6))) - normcdf(is_e*log(expeCL(iA6,2)));
       end
       lI_temp = log(PR);
       
       l_temp = l(iT(ikldT(iCkldT(iCcr0))));
       expe_AK_temp = expe_AK(ikldT(iCkldT(iCcr0)));
       parfor j = 1:nCcr0
            iw = find(Psp_temp(j,:)>0,1);
            Pars = [a w0 l_temp(j) A_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            x0H = Wsp_temp(j,iw)/(l_temp(j)*w0) - 1e-6;
            x0 = [x0L x0H];    
            f = @(x)inv_S(x,Pars);
            if inv_S(x0L,Pars)*inv_S(x0H,Pars)<0
                expe_tC = fzero(f,x0);
            elseif abs(inv_S(x0L,Pars)) < abs(inv_S(x0H,Pars))
                expe_tC = x0L;
            else
                expe_tC = x0H;
            end
            HM = (Wsp_temp(j,:)/(w0*expe_tC) - l_temp(j)).^(a-2);
            J = HM*Psp_temp(j,:)'*w0*expe_tC/((HM.*Wsp_temp(j,:))*Psp_temp(j,:)');      
            S = a*J*is_e.*normpdf(a*is_e*log(expe_tC));
            PR0 = max(normcdf(is_e*log(expe_AK_temp(j))),1e-5); 
            lI_temp(j) = lI_temp(j) + log(S) - log(PR0);
       end
       lI(iT(ikldT(iCkldT(iCcr0)))) = lI_temp; 
    end

    iCcr2 = find(zminval(iCkldT)<0);
    nCcr2 = length(iCcr2);
    if nCcr2 > 0
         expeLA = expeLAK(ikldT(iCkldT(iCcr2)));
         expeCA = expeCAK(ikldT(iCkldT(iCcr2)));
         expePA = expePAK(ikldT(iCkldT(iCcr2)));
         expeCL = zeros(nCcr2,2);
         expeCP = zeros(nCcr2,2);
         expePL = zeros(nCcr2,2);
         
         delta_temp = delta(iT(ikldT(iCkldT(iCcr2))));
         Vug_temp = Vug(iT(ikldT(iCkldT(iCcr2))));
         Vu_temp = Vu(iT(ikldT(iCkldT(iCcr2))));
         K_L_temp = K_L(iT(ikldT(iCkldT(iCcr2))));
         K_T_temp = K_T(iT(ikldT(iCkldT(iCcr2))));
         Psp_temp = Psp(iT(ikldT(iCkldT(iCcr2))),:);
         Wsp_temp = Wsp(iT(ikldT(iCkldT(iCcr2))),:);
         A_temp = A(iT(ikldT(iCkldT(iCcr2))));
         expeH_temp = expeH(iT(ikldT(iCkldT(iCcr2))));
         C_1_temp = C_1(ikldT(iCkldT(iCcr2)));
         C_2_temp = C_2(ikldT(iCkldT(iCcr2)));
         zmin_temp = zmin(ikldT(iCkldT(iCcr2)));
         
         parfor j = 1:nCcr2
            ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCL(j,:) = expe_CL(ParCL,pts,niter);
            ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) zmin_temp(j) expeH_temp(j)];
            expePL(j,:) = expe_PLr2(ParPL);
            ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            expeCP(j,:) = expe_CP(ParCP,pts,niter);
         end
         
        iD1 = find((expeCL(:,1) < expePL(:,1)) + (expeCA > expeLA) + (expeCA > expePA) + (expeCL(:,2) > expeCA) + (expeCP(:,2) > expeCA) == 5);    
        iD2 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD3 = find((expePL(:,2) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA > expeLA) + (expeCA > expePA) == 5);
        iD5 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expeCL(:,2) > expePL(:,2)) + (expeCL(:,2) < expeCA) + (expeCA < expeLA) + (expePA < expeLA) == 6); 
        iD5 = [iD5; find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,2) < expeCA) + (expeCA < expeLA) + (expeLA < expePL(:,1)) + (expePA < expeLA) == 5)];
        iD6 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 8);  
        iD7 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,2)) + (expePL(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD8 = find((expePL(:,1) < expeCL(:,1)) + (expeCL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expePL(:,2)) + (expePL(:,2) < expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 7);  
        iD9 = find((expeCA < expeCL(:,1)) + (expeCA < expeCP(:,1)) + (expeCA > expeLA) + (expeCA > expePA) == 4); 
        iD10 = find((expePL(:,2) < expeCL(:,1)) + (expeCL(:,1) < expeCA) + (expeCA < expeLA) + (expePA < expeLA) == 4); 
        iD10 = [iD10; find((expeCL(:,1) < expeCP(:,1)) + (expePA < expeLA) + (expeCA < expeLA) + (expeLA < expePL(:,1)) + (expeLA > expeCL(:,2)) == 5)];       
        iD11 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,2)) + (expePL(:,2) < expePA) + (expePA < expeLA) + (expeCA < expePA) == 6);  
        iD12 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,2)) + (expeCL(:,2) > expeLA) + (expeCA < expeLA) + (expePA < expeLA) == 6);  
        iD13 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,1) < expeCL(:,2)) + (expeCL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expePL(:,2)) + (expeCP(:,2) < expeCA) + (expeLA < expeCA) + (expePA < expeCA) == 8);  
        iD14 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) +  (expePL(:,2) < expeCP(:,2)) + (expeCP(:,2) < expeCL(:,2)) + (expeCL(:,2) < expeLA) + (expeLA < expeCA) + (expePA < expeCA) == 7);  
        iD15 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePL(:,2)) + (expeCL(:,1) > expeCA) + (expeCP(:,2) < expePA) + (expeLA < expeCA) + (expePA < expeCA) + (expeCP(:,2) < expeCA) == 6);  
        iD16 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePL(:,2)) + (expePL(:,2) < expeCL(:,1)) + (expeCL(:,1) < expeCA) + (expeCA < expeLA) + (expePA < expeCA) == 6);  
        iE4 = find((expeCP(:,1) < expeCL(:,1)) + (expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,2)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,2)) == 6);  
        iE6 = find((expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeCL(:,1)) + (expePA < expePL(:,2)) + (expeLA < expePA) + (expeCA < expePA) == 5);  
        iE7 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
       
        iDN1 = find((expeCL(:,2) < expePL(:,1)) +  (expePL(:,1) < expeLA) + (expePA > expeLA) == 3);
        iDN2 = find((expePL(:,1) < expeCP(:,1)) +  (expeCP(:,2) < expeCA) + (expeCA < expePA) == 3);
        iDN3 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expePA) + (expePA > expeLA) + (expePA > expeCA) == 5);  
        iDN4 = find((expeCL(:,1) < expeCP(:,1)) + (expeCP(:,1) < expeLA) + (expeLA < expePL(:,1)) + (expeLA > expePA) + (expeLA > expeCA) == 5);  
        iDN5 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCA) + (expeCA > expeLA) + (expeCA > expePA) == 4);
        iDN6 = find((expeCL(:,1) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expeCA) + (expeCA < expePA) + (expePA < expePL(:,1)) == 5);  
        iDN7 = find((expeCL(:,2) < expePL(:,1)) + (expePL(:,1) < expeCP(:,1)) + (expeCP(:,2) < expePA) + (expeCA > expeLA) + (expeCA > expePA) == 5);

        expe_H = expeCP(:,1);
        expe_L = expeCL(:,1);

        expe_H([iD10;iD12;iD13;iD14;iDN3;iDN5;iDN7]) = expeCL([iD10;iD12;iD13;iD14;iDN3;iDN5;iDN7],1);
        if ~isempty(iDN1)
            expe_H(iDN1) = expeCL(iDN1,2);
        end
        
        expe_H([iD5;iD7;iDN2]) = expeCP([iD5;iD7;iDN2],2);
        expe_H([iD1;iD2;iD3;iD9]) = expeCA([iD1;iD2;iD3;iD9]);
    
        expe_L([iD2;iD7;iD8;iDN2]) = expeCP([iD2;iD7;iD8;iDN2],1);
        
        PR = 1e-6*ones(nCcr2,1);
        
        iR = [iD9;iD10;iD11;iD12;iD13;iD14;iD15;iD16;iE6;iE7;iDN3;iDN4;iDN5;iDN7];
        PR(iR) = normcdf(is_e*log(expe_H(iR)));
        
        iR = [iD1;iD2;iD3;iD5;iD6;iD7;iD8;iE4;iDN1;iDN2;iDN6];
        PR(iR) = (normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expe_L(iR)))); 
        
        iR = [iD13;iD15;iDN4]; 
        if ~isempty(iR)    
            PR(iR) = PR(iR) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCP(iR,2)));
        end
        iR = iDN6; 
        if ~isempty(iR)    
            PR(iR) = PR(iR) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCP(iR,2)));
        end

        iR = [iD14;iDN5];
        if ~isempty(iR)
            PR(iR) = PR(iR) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCL(iR,2)));
        end    
        iR = iDN3;
        if ~isempty(iR)
            PR(iR) = PR(iR) + normcdf(is_e*log(expeCP(iR,1))) - normcdf(is_e*log(expeCL(iR,2)));
        end    
        iR = iDN7;
        if ~isempty(iR)
            PR(iR) = PR(iR) + normcdf(is_e*log(expeCP(iR,1))) - normcdf(is_e*log(expeCL(iR,2))) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCP(iR,2)));
        end    
       
        lI_temp = log(PR);   

        l_temp = l(iT(ikldT(iCkldT(iCcr2))));
        expe_AK_temp = expe_AK(ikldT(iCkldT(iCcr2)));
        parfor j = 1:nCcr2
            iw = find(Psp_temp(j,:)>0,1);
            Pars = [a w0 l_temp(j) A_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
            x0H = Wsp_temp(j,iw)/(l_temp(j)*w0) - 1e-6;
            x0 = [x0L x0H];    
            f = @(x)inv_S(x,Pars);
            if inv_S(x0L,Pars)*inv_S(x0H,Pars)<0
                expe_tC = fzero(f,x0);
            elseif abs(inv_S(x0L,Pars)) < abs(inv_S(x0H,Pars))
                expe_tC = x0L;
            else
                expe_tC = x0H;
            end
            HM = (Wsp_temp(j,:)/(w0*expe_tC) - l_temp(j)).^(a-2);
            J = HM*Psp_temp(j,:)'*w0*expe_tC/((HM.*Wsp_temp(j,:))*Psp_temp(j,:)');      
            S = a*J*is_e.*normpdf(a*is_e*log(expe_tC));
            PR0 = max(normcdf(is_e*log(expe_AK_temp(j))),1e-5); 
            lI_temp(j) = lI_temp(j) + log(S) - log(PR0);
        end 
        lI(iT(ikldT(iCkldT(iCcr2)))) = lI_temp;
    end
end

iCksdT = find(choice(iT(iksdT))==3);

if sum(iCksdT)>0    
    nCksd = length(iCksdT);
    expeLA = expeLAK(iksdT(iCksdT));
    expeCA = expeCAK(iksdT(iCksdT));
    expePA = expePAK(iksdT(iCksdT));
    expeCP = zeros(nCksd,2);
    expeHLc = expeHL(iT(iksdT(iCksdT)),1);
    expeHc = expeH(iT(iksdT(iCksdT)),1);
    expeCL = zeros(nCksd,2);
    expePL = zeros(nCksd,1);
    
    delta_temp = delta(iT(iksdT(iCksdT)));
    Vug_temp = Vug(iT(iksdT(iCksdT)));
    Vu_temp = Vu(iT(iksdT(iCksdT)));
    K_L_temp = K_L(iT(iksdT(iCksdT)));
    K_T_temp = K_T(iT(iksdT(iCksdT)));
    Psp_temp = Psp(iT(iksdT(iCksdT)),:);
    Wsp_temp = Wsp(iT(iksdT(iCksdT)),:);
    A_temp = A(iT(iksdT(iCksdT)));
    expeH_temp = expeH(iT(iksdT(iCksdT)));
    C_1_temp = C_1(iksdT(iCksdT));
    C_2_temp = C_2(iksdT(iCksdT));

    parfor j = 1:nCksd
        ParPL = [a C_1_temp(j) C_2_temp(j) K_L_temp(j) K_T_temp(j) expeH_temp(j)];
        expePL(j,1) = expe_PLr1(ParPL);

        ParCL = [a c w0 K_L_temp(j) K_T_temp(j) g A_temp(j) Vug_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCL(j,:) = expe_CL(ParCL,pts,niter);
    
        ParCP = [a c w0 delta_temp(j) A_temp(j) Vu_temp(j) expeH_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        expeCP(j,:) = expe_CP(ParCP,pts,niter);    
    end;

    iB1 = find((expeLA > expePA) + (expeCP(:,1) < expePL) + (expeCL(:,2) > expeCA) + (expeLA < expeCA) == 4);
    iB2 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,1) > expeCP(:,1)) + (expeCL(:,1) < expeCA) + (expeLA < expeCA) + (expeCL(:,1) < expeHLc) == 6);
    iB4 = find((expeLA > expePA) + ((expeCL(:,2).*(expeCL(:,2)<5*expeHc) > expePL) | (expeCL(:,1).*(expeCL(:,2)>5*expeHc) > expePL)) + (expeCP(:,1) < expePL(:,1)) + (expeCP(:,2) > expePL(:,1)) + (expeCL(:,1) < expeLA) + (expeCA < expeLA) == 6);    
    iB5 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeLA > expeCA) == 3);
    iB6 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,2) < expeLA) + (expeCA < expeLA) == 4);

    iB7 = find((expeLA > expePA) + (((expeCL(:,1) > expeCA) & (expeCL(:,1) < expeHLc)) | (expeCL(:,1) > expeHLc)) + (expeCP(:,1) > expeHLc) + (expeLA < expeCA) + (expeCA < expeHc-1e-6) == 5);
    iB8 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCP(:,1) > expeCL(:,1)) + (expeCL(:,1) < expeLA) + (expeLA > expeCA) == 5);
    iB9 = find((expeLA > expePA) + (expeCL(:,1) < expePL) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCP(:,1) < expeCL(:,1)) + (expeLA > expeCA) == 6);
    iB10 = find((expeLA > expePA) + (expeCP(:,2) < expePL) + (expeCL(:,1) > expePL) + (expeCA < expeLA) == 4);    
    iB11 = find((expeLA > expePA) + (expeCP(:,1) < expePL) + (expeCP(:,2) > expePL) + (expeCL(:,2) < expeCA) + (expeCA > expeLA) == 5);
    iB12 = find((expeLA > expePA) + (expeCL(:,1) > expePL) + (expeCL(:,2) < expeLA) + (expeCL(:,1) < expeCP(:,1)) + (expeCA > expeLA) == 5);
       
    iC1 = find((expeLA < expePA) + (expeCP(:,1) < expePA) + (expeCP(:,2) > expePA) + (expePA < expeCA) == 4);
    R = zeros(nCksd,11);
    R(iB1,1) = 1; R(iB2,2) = 1; R(iB4,3) = 1; R(iB5,4) = 1; R(iB6,5) = 1; R(iB7,6) = 1;
    R(iB8,7) = 1; R(iB9,8) = 1; R(iB10,9) = 1; R(iB11,10) = 1; R(iB12,11) = 1;
    sR = sum(R,2);
    iC1 = [iC1;find((sR==0) + (expeCP(:,1) < expePA) + (expeCP(:,2) < expePA) + (expePA < expeCA) == 4)];

    iC3 = find((expeLA < expePA) + (expeCP(:,2) < expePA) + (expePA > expeCA) == 3);
    iC4 = find((expeLA < expePA) + (expeCP(:,1) > expePA) + (expePA < expeCA) == 3);
    iC5 = find((expeLA < expePA) + (expeCP(:,1) < expeCA) + (expeCP(:,2) > expePA) + (expeCA < expePA) == 4);
    iC6 = find((expeLA < expePA) + (expeCP(:,1) < expeCL(:,1)) + (expeCP(:,2) < expePA) + (expePA < expeCA) == 4);


    expe_H = expeCA;
    expe_H([iB8;iB12]) = expeCL([iB8;iB12],1);
    if ~isempty(iB4)
        expe_H(iB4) = (expeCL(iB4,2)>expeLA(iB4)).*expeCL(iB4,1) + (expeCL(iB4,2)<expeLA(iB4)).*expeCL(iB4,2);
    end
    expe_H(iB6) = expeCL(iB6,2);
    expe_H([iB9;iB10;iB11;iC5;iC6]) = expeCP([iB9;iB10;iB11;iC5;iC6],1);
    expe_H([iB5;iC3]) = expeCP([iB5;iC3],2);

    expe_L = expeCP(:,1);
    expe_L([iB2;iB6]) = expeCL([iB2;iB6],1);
    
    PR = 1e-6*ones(nCksd,1);

    iR = [iB7;iB8;iB9;iB10;iB11;iB12;iC4;iC5;iC6];
    if ~isempty(iR)
       PR(iR)= normcdf(is_e*log(expe_H(iR)));
    end 

    iR = [iB1;iB2;iB4;iB6;iC1;iC3];
    if ~isempty(iR)
       PR(iR) = normcdf(is_e*log(expe_H(iR))) - normcdf(is_e*log(expe_L(iR)));
    end
    iR = iB10;    
    if ~isempty(iR)
        PR(iR) = PR(iR) + normcdf(is_e*log(expeCL(iR,1))) - normcdf(is_e*log(expeCP(iR,2)));
    end
    iR = [iB11;iB12];
    if ~isempty(iR)
        PR(iR) = PR(iR) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCL(iR,2)));
    end
    iR = iC6;
    if ~isempty(iR)
        PR(iR) = PR(iR) + normcdf(is_e*log(expeCA(iR))) - normcdf(is_e*log(expeCP(iR,2)));
    end

    lI_temp = log(PR);   

    l_temp = l(iT(iksdT(iCksdT)));
    expe_AK_temp = expe_AK(iksdT(iCksdT));
    
    parfor j = 1:nCksd
        iw = find(Psp_temp(j,:)>0,1);
        Pars = [a w0 l_temp(j) A_temp(j) Wsp_temp(j,:) Psp_temp(j,:)];
        x0H = Wsp_temp(j,iw)/(l_temp(j)*w0) - 1e-6;
        x0 = [x0L x0H];    
        f = @(x)inv_S(x,Pars);
        if inv_S(x0L,Pars)*inv_S(x0H,Pars)<0
            expe_tC = fzero(f,x0);
        elseif abs(inv_S(x0L,Pars)) < abs(inv_S(x0H,Pars))
            expe_tC = x0L;
        else
            expe_tC = x0H;
        end
        HM = (Wsp_temp(j,:)/(w0*expe_tC) - l_temp(j)).^(a-2);
        J = HM*Psp_temp(j,:)'*w0*expe_tC/((HM.*Wsp_temp(j,:))*Psp_temp(j,:)');      
        S = a*J*is_e.*normpdf(a*is_e*log(expe_tC));
        PR0 = max(normcdf(is_e*log(expe_AK_temp(j))),1e-5); 
        lI_temp(j) = lI_temp(j) + log(S) - log(PR0);
    end
    lI(iT(iksdT(iCksdT))) = lI_temp;
end

Q = -1*sum(lI)/n;
end

