% Program that maximizes the likelihood function;

clear all;

load d_est_allhold_final.mat;
sample = 0;
dist_id = st_dataset{:,1}; 
gw_markets_id = st_dataset{:,2}; 
w_id = st_dataset{:,3};
d_holdout = (dist_id == 2 | dist_id == 5);
w_pipe_width = st_dataset{:,6};
w_14 = st_dataset{:,7}; 
w_12 = st_dataset{:,8}; 
w_34 = st_dataset{:,9}; 
w_1 = st_dataset{:,10}; 
pr_14 = st_dataset{:,11}; 
pr_12 = st_dataset{:,12}; 
pr_34 = st_dataset{:,13}; 
pr_1 = st_dataset{:,14}; 
choice_all = st_dataset{:,15}; 
A_all = st_dataset{:,16}; 
lA_all = st_dataset{:,17}; 
l_all = st_dataset{:,18}; 
avAadj_all = st_dataset{:,19}; 
avArel_all = st_dataset{:,21}; 
avAcaste_all = st_dataset{:,22}; 

Psp_all = [pr_14 pr_12 pr_34 pr_1];
Wsp_all = (w_pipe_width.^2)*[.25 .5 .75 1];
        
ieposP = find(d_holdout == 0 & sum(Psp_all,2)<.999);
ie = find(d_holdout == 0 & sum(Psp_all,2)>=.999);

ibadW = find(isnan(Wsp_all(ie,1)));
ibadA = find(isnan(avAadj_all(ie,1)));
ibad = sort([ibadW;ibadA]);
temp = [1:length(ie)]';

if sample
   rng(12345); 
   rnd = rand(length(temp),1);
   [~,irnd] = sort(rnd);
   cut = round(length(temp)/6);
   nosamp = irnd(cut:length(temp));
   temp(nosamp) = 0;
end
temp(ibad) = 0;
igood =nonzeros(temp);

if ~isempty(ieposP)
    tempposP = [1:length(ieposP)]'; 
    rnd = rand(length(ieposP),1);
    [~,irnd] = sort(rnd);
    cut = round(length(ieposP)/2);
    nosamp = irnd(1:cut);
    tempposP(nosamp) = 0;
    ibadWposP = find(isnan(Wsp_all(ieposP,1)));
    ibadAposP = find(isnan(avAadj_all(ieposP,1)));
    ibadposP = sort([ibadWposP;ibadAposP]);
    tempposP(ibadposP) = 0;
    igoodposP =nonzeros(tempposP);
end;

Igood = sort([ie(igood);ieposP(igoodposP)]);
choice = choice_all(Igood);
l = l_all(Igood);
A = A_all(Igood);
Wsp0 = Wsp_all(Igood,:);
Psp = Psp_all(Igood,:);
avAadj = (1/.35)*avAadj_all(Igood);   %multiplying by 1/.35 to get log(avAadj) always positive;       
avArel = avArel_all(Igood);
avAcaste = avAcaste_all(Igood)/100;

R.MatPar0 = [0.2 0.5 0.003 -2.5  -0.2 0 0.2 0.01 0.05 4 0.75]; 
[niter npar] = size(R.MatPar0);

options_fsearch = optimset('Display','iter','TolFun',1e-5,'MaxFunEvals',9600);

tic;
for j = 1:niter
    Par0 = R.MatPar0(j,1:npar);
    X0 = P2Xn(Par0);
    g = @(X0)fn(X0,choice,l,A,Wsp0,Psp,avAadj,avAcaste);
    [BX,fval] = fminsearch(g,X0,options_fsearch);
    BPar = X2Pn(BX);
    R.MatBPar(j,:) = [BPar fval];

    disp(fprintf(' a = %1.5f  | c = %1.5f g =  %1.5f | eta_0 = %1.5f  | eta_1 = %1.5f  | eta_2 = %1.5f  | k_L = %1.5f | k_T = %1.5f |  b = %1.5f | is = %1.5f | l = %1.5f  \n',BPar));

    S1 = datestr(now);
end;
str = sprintf('Bparml_final R');
eval(['save ',str]);
toc;
