% Program that maximizes the likelihood function;

clear all;

load d_est_allhold_final.mat;
sample = 0;
dist_id = st_dataset{:,1}; 
gw_markets_id = st_dataset{:,2}; 
w_id = st_dataset{:,3};
d_holdout = (dist_id == 2 | dist_id == 5);
w_pipe_width = st_dataset{:,6};
w_14 = st_dataset{:,7}; 
w_12 = st_dataset{:,8}; 
w_34 = st_dataset{:,9}; 
w_1 = st_dataset{:,10}; 
pr_14 = st_dataset{:,11}; 
pr_12 = st_dataset{:,12}; 
pr_34 = st_dataset{:,13}; 
pr_1 = st_dataset{:,14}; 
choice_all = st_dataset{:,15}; 
A_all = st_dataset{:,16}; 
lA_all = st_dataset{:,17}; 
l_all = st_dataset{:,18}; 
avAadj_all = st_dataset{:,19}; 
avArel_all = st_dataset{:,21}; 
avAcaste_all = st_dataset{:,22}; 

Psp_all = [pr_14 pr_12 pr_34 pr_1];
Wsp_all = (w_pipe_width.^2)*[.25 .5 .75 1];
        
ieposP = find(d_holdout == 0 & sum(Psp_all,2)<.999);
ie = find(d_holdout == 0 & sum(Psp_all,2)>=.999);

ibadW = find(isnan(Wsp_all(ie,1)));
ibadA = find(isnan(avAadj_all(ie,1)));
ibad = sort([ibadW;ibadA]);
temp = [1:length(ie)]';

if sample
   rng(12345); 
   rnd = rand(length(temp),1);
   [~,irnd] = sort(rnd);
   cut = round(length(temp)/6);
   nosamp = irnd(cut:length(temp));
   temp(nosamp) = 0;
end
temp(ibad) = 0;
igood =nonzeros(temp);

if ~isempty(ieposP)
    tempposP = [1:length(ieposP)]'; 
    rnd = rand(length(ieposP),1);
    [~,irnd] = sort(rnd);
    cut = round(length(ieposP)/2);
    nosamp = irnd(1:cut);
    tempposP(nosamp) = 0;
    ibadWposP = find(isnan(Wsp_all(ieposP,1)));
    ibadAposP = find(isnan(avAadj_all(ieposP,1)));
    ibadposP = sort([ibadWposP;ibadAposP]);
    tempposP(ibadposP) = 0;
    igoodposP =nonzeros(tempposP);
end;

Igood = sort([ie(igood);ieposP(igoodposP)]);
choice = choice_all(Igood);
l = l_all(Igood);
A = A_all(Igood);
Wsp0 = Wsp_all(Igood,:);
Psp = Psp_all(Igood,:);
avAadj = (1/.35)*avAadj_all(Igood);   %multiplying by 1/.35 to get log(avAadj) always positive;       
d_id = dist_id(Igood);
avArel = avArel_all(Igood,:);
avAcaste = avAcaste_all(Igood,:);

n = length(l);

i_1 = find(d_id==1);
i_3 = find(d_id==3);
i_4 = find(d_id==4);
i_6 = find(d_id==6);

choice1 = choice(i_1);
choice3 = choice(i_3);
choice4 = choice(i_4);
choice6 = choice(i_6);

l1 = l(i_1);
l3 = l(i_3);
l4 = l(i_4);
l6 = l(i_6);

A1 = A(i_1);
A3 = A(i_3);
A4 = A(i_4);
A6 = A(i_6);

Wsp0_1 = Wsp0(i_1,:);
Wsp0_3 = Wsp0(i_3,:);
Wsp0_4 = Wsp0(i_4,:);
Wsp0_6 = Wsp0(i_6,:);

Psp1 = Psp(i_1,:);
Psp3 = Psp(i_3,:);
Psp4 = Psp(i_4,:);
Psp6 = Psp(i_6,:);

avAadj1 = avAadj(i_1);
avAadj3 = avAadj(i_3);
avAadj4 = avAadj(i_4);
avAadj6 = avAadj(i_6);

avArel1 = avArel(i_1);
avArel3 = avArel(i_3);
avArel4 = avArel(i_4);
avArel6 = avArel(i_6);

avAcaste1 = avAcaste(i_1);
avAcaste3 = avAcaste(i_3);
avAcaste4 = avAcaste(i_4);
avAcaste6 = avAcaste(i_6);

load Bparml_final;

Par0 = R.MatBPar;

clear R;

R.MatPar0 = [Par0(1)*ones(1,4) Par0(2)*ones(1,4) Par0(3:11)];

[niter npar] = size(R.MatPar0);
options_fsearch = optimset('Display','iter','TolFun',1e-5,'MaxFunEvals',9600);

for j = 1:niter
    Par0 = R.MatPar0(j,1:npar);
    X0 = P2Xac(Par0);
    g = @(X0)fac(X0,choice1,choice3,choice4,choice6,l1,l3,l4,l6,A1,A3,A4,A6,Wsp0_1,Wsp0_3,Wsp0_4,Wsp0_6,Psp1,Psp3,Psp4,Psp6,avAadj1,avAadj3,avAadj4,avAadj6,avAcaste1,avAcaste3,avAcaste4,avAcaste6,n);
    [BX,fval] = fminsearch(g,X0,options_fsearch);
    BPar = X2Pac(BX);
    R.MatBPar(j,:) = [BPar fval];

    disp(fprintf(' a_1 = %1.5f  | a_3 = %1.5f | a_4 = %1.5f | a_6 = %1.5f | c_1 = %1.5f | c_3 = %1.5f | c_4 = %1.5f | c_6 = %1.5f | g =  %1.5f | eta_0 = %1.5f  | eta_1 = %1.5f  | eta_2 = %1.5f  | k_L = %1.5f | k_T = %1.5f |  b = %1.5f | is = %1.5f | l = %1.5f  \n',BPar));

    S1 = datestr(now);
end;
str = sprintf('Bparml4ac_final R');
eval(['save ',str]);
