clear all;

   %load ../data/est/Res_finalacv2_50;
load Res4ac_final;

filtex = 'res4ac_final.tex';

eval(['!del ',filtex]);
eval(['!copy introtab.tex ',filtex]);

ne = Rres.Ne;
LL = -Rres.mld*ne;
Par = Rres.Par;

diP = [Par(1:15) 1/Par(16) Par(17)];

res = [ne; LL; diP'];
[np,nsp] = size(res);  
strpar = {'N. Obs','Log-L.','$\alpha_1$','$\alpha_3$','$\alpha_4$','$\alpha_6$','$c_1$','$c_3$','$c_4$','$c_6$','$\gamma$','$\eta_0$','$\eta_1$','$\eta_2$','$k_L$','$k_T$','$\beta$','$\sigma_{\epsilon}$','$\lambda$'};

eval (['diary ',filtex]);
disp('\begin{table}');
disp(['\begin{tabular}{|c|c|} \hline']);
disp(['& Coeff \\ \hline']);
for i = 1:length(strpar) 
    str = sprintf('%s',char(strpar(i)));       
    str = [str sprintf(' & %1.3f',res(i))];
          disp([str ' \\ ']); 
end;
disp([' \hline ']); 
eval(['diary ',filtex]);
disp('\end{tabular}');
disp('\end{table}');
diary off;

MData = [Rres.DPe;Rres.MPe;Rres.DPh1;Rres.MPh1;Rres.DPh2;Rres.Mh2;Rres.MPs1;Rres.MPm1;]';
LData = [Rres.DLe;Rres.MLe;Rres.DLh1;Rres.MLh1;Rres.DLh2;Rres.MLh2;Rres.MLs1;Rres.MLm1]';
LMData = [Rres.DLMe;Rres.MLMe;Rres.DLMh1;Rres.MLMh1;Rres.DLMh2;Rres.MLMh2;Rres.MLMs1;Rres.MLMm1]';

EData = [Rres.etae;Rres.etah1;Rres.etah2]';

strvarM = {'$Pr(U)$','$Pr(A)$','$Pr(L)$','$Pr(P)$','$Pr(C)$'}; 
strvarL = {'$E[\ell]$','$SD[\ell]$'}; 
strvareta = {'$E[\eta]$','$SD[\eta]$'}; 
strvarLM = {'$E[\ell(U)]$','$E[\ell(A)]$','$E[\ell(L)]$','$E[\ell(P)]$','$E[\ell(C)]$','$E[\ell(NT)]$','$E[\ell(T)]$'}; 

eval (['diary ',filtex]);
disp('\begin{table}');
disp(['\begin{tabular}{lcccccccc} \hline']);
disp(['& \multicolumn{2}{c}{Estimation Sample} & \multicolumn{6}{c}{Holdout Sample} \\ \hline']);
disp(['& Data & Model & Data & Model & Data & Model & $\Delta \sigma_w$ & $\Delta \sigma_w + \mu_w$  \\ \hline']);
for i = 1:length(strvarM) 
    str = sprintf('%s',char(strvarM(i)));       
    str = [str sprintf(' & %1.2f & %1.2f & %1.2f  & %1.2f & %1.2f & %1.2f & %1.2f & %1.2f',MData(i,:))];
    disp([str ' \\ ']); 
end;
disp([' \hline ']); 
for i = 1:length(strvarL) 
    str = sprintf('%s ',char(strvarL(i)));       
    str = [str sprintf(' & %1.2f & %1.2f  & %1.2f & %1.2f & %1.2f & %1.2f & %1.2f & %1.2f',LData(i,:))];
    disp([str ' \\ ']); 
end;
str = ['$\rho(\ell)$']; 
str = [str sprintf(' & %1.2f & & %1.2f & & %1.2f & & &   ',Rres.Lcorre(1),Rres.Lcorrh1(1),Rres.Lcorrh2(1))];
disp([str ' \\ ']); 

for i = 1:length(strvarLM) 
    str = sprintf('%s ',char(strvarLM(i)));       
    str = [str sprintf(' & %1.2f & %1.2f  & %1.2f & %1.2f & %1.2f & %1.2f & %1.2f & %1.2f',LMData(i,:))];
    disp([str ' \\ ']); 
end;
disp([' \hline \hline']); 
disp('\end{tabular}');
disp('\end{table}');

disp('\begin{table}');
disp(['\begin{tabular}{lccc} \hline']);
disp(['& Estimation & Holdout 1 & Holdout 2  \\ \hline']);
for i = 1:length(strvareta) 
    str = sprintf('%s',char(strvareta(i)));       
    str = [str sprintf(' & %1.5f & %1.5f & %1.5f ',EData(i,:))];
    disp([str ' \\ ']); 
end;
disp([' \hline \hline ']); 
disp('\end{tabular}');
disp('\end{table}');

strvarTM = {'$U$','$A$','$L$','$P$','$C$'}; 

disp('\begin{table}');
disp(['\begin{tabular}{c|ccccc|c} \hline']);
disp(['& Pr($U$) & Pr($A$) & Pr($L$) & Pr($P$) & Pr($C$) \\ \hline']);
for i = 1:length(strvarTM) 
    str = sprintf('%s',char(strvarTM(i)));       
    str = [str sprintf(' & %1.3f & %1.3f & %1.3f  & %1.3f & %1.3f',Rres.MatPre(i,:))];
    disp([str ' \\ ']); 
end;
disp([' \hline \hline']); 
disp('\end{tabular}');
disp('\end{table}');

disp('\end{document}');
diary off;

