clear all;

load d_est_allhold_final.mat;

dist_id = st_dataset{:,1}; 
gw_markets_id = st_dataset{:,2}; 
w_id = st_dataset{:,3};
d_holdout = (dist_id == 2 | dist_id == 5);
w_pipe_width = st_dataset{:,6};
w_14 = st_dataset{:,7}; 
w_12 = st_dataset{:,8}; 
w_34 = st_dataset{:,9}; 
w_1 = st_dataset{:,10}; 
pr_14 = st_dataset{:,11}; 
pr_12 = st_dataset{:,12}; 
pr_34 = st_dataset{:,13}; 
pr_1 = st_dataset{:,14}; 
choice_all = st_dataset{:,15}; 
A_all = st_dataset{:,16}; 
lA_all = st_dataset{:,17}; 
l_all = st_dataset{:,18}; 
avAadj_all = st_dataset{:,19}; 
avArel_all = st_dataset{:,21}; 
avAcaste_all = st_dataset{:,22}; 

Psp_all = [pr_14 pr_12 pr_34 pr_1];
Wsp_all = (w_pipe_width.^2)*[.25 .5 .75 1];
        
ieposP = find(d_holdout == 0 & sum(Psp_all,2)<.999);
ie = find(d_holdout == 0 & sum(Psp_all,2)>=.999);

ibadWe = find(isnan(Wsp_all(ie,1)));
ibadAe = find(isnan(avAadj_all(ie,1)));
ibade = sort([ibadWe;ibadAe]);
tempe = [1:length(ie)]';
tempe(ibade) = 0;

igoodzeroPe =nonzeros(tempe);

if ~isempty(ieposP)
    ibadWposP = find(isnan(Wsp_all(ieposP,1)));
    ibadAposP = find(isnan(avAadj_all(ieposP,1)));
    ibadposPe = sort([ibadWposP;ibadAposP]);
    tempposPe = [1:length(ieposP)]'; 
    tempposPe(ibadposPe) = 0;   
    igoodposPe =nonzeros(tempposPe);
    igoode = sort([ie(igoodzeroPe);ieposP(igoodposPe)]);

else
    igoode = sort(ie(igoodzeroPe));
end;

choice = choice_all(igoode);
l = l_all(igoode);
A = A_all(igoode);
Wsp0 = Wsp_all(igoode,:);
Psp = Psp_all(igoode,:);
avAadj = (1/.35)*avAadj_all(igoode);
avArel = avArel_all(igoode);
avAcaste = avAcaste_all(igoode);

gw_markets_id_e = gw_markets_id(igoode,1); 
w_id_e = w_id(igoode,1);

ih1 = find(d_holdout == 1 & dist_id == 2);
ibadWh1 = find(isnan(Wsp_all(ih1,1)));
ibadAh1 = find(isnan(avAadj_all(ih1,1)));
ibadh1 = sort([ibadWh1;ibadAh1]);
temph1 = [1:length(A_all(ih1))]';
temph1(ibadh1) = 0;
igoodh1 = nonzeros(temph1);

choiceh1 = choice_all(ih1(igoodh1));
lh1 = l_all(ih1(igoodh1));
Ah1 = A_all(ih1(igoodh1));
Wsp0h1 = Wsp_all(ih1(igoodh1),:);
Psph1 = Psp_all(ih1(igoodh1),:);
avAadjh1 = (1/.35)*avAadj_all(ih1(igoodh1));  
avArelh1 = avArel_all(ih1(igoodh1));
avAcasteh1 = avAcaste_all(ih1(igoodh1));
gw_markets_id_h1 = gw_markets_id(ih1(igoodh1),1); 
w_id_h1 = w_id(ih1(igoodh1),1);

ih2 = find(d_holdout == 1 & dist_id == 5);
ibadWh2 = find(isnan(Wsp_all(ih2,1)));
ibadAh2 = find(isnan(avAadj_all(ih2,1)));
ibadh2 = sort([ibadWh2;ibadAh2]);
temph2 = [1:length(A_all(ih2))]';
temph2(ibadh2) = 0;
igoodh2 = nonzeros(temph2);

choiceh2 = choice_all(ih2(igoodh2));
lh2 = l_all(ih2(igoodh2));
Ah2 = A_all(ih2(igoodh2));
Wsp0h2 = Wsp_all(ih2(igoodh2),:);
Psph2 = Psp_all(ih2(igoodh2),:);
avAadjh2 = (1/.35)*avAadj_all(ih2(igoodh2));  
avArelh2 = avArel_all(ih2(igoodh2));
avAcasteh2 = avAcaste_all(ih2(igoodh2));
gw_markets_id_h2 = gw_markets_id(ih2(igoodh2),1); 
w_id_h2 = w_id(ih2(igoodh2),1);

ne = length(A);
nh1 = length(Ah1);
nh2 = length(Ah2);

nsamp = 50;
bsamp = 100;

fP2X = 'P2Xn';
fX2P = 'X2Pn';

fil = 'Bparml_final';
filres = 'Res_final Rres';
    
eval(['load ',fil]);

[niter, npar] = size(R.MatPar0);
[mld,ind] = min(R.MatBPar(1:niter,npar+1));

Par = R.MatBPar(ind,1:npar);

clear R;

X = feval(fP2X,Par);

%ParM = bsn(X,gw_markets_id_e,w_id_e,choice,l,A,Wsp0,Psp,avAadj,avAcaste,bsamp); 
%disp('BS finished');

[ProbMe,prese,Drese,lMrese,TMPe,Gvece,Ivece,lIvece,ResMe] = fPsim1n(Par,nsamp,A,l,Wsp0,Psp,avAadj,avAcaste);
[ProbMh1,presh1,Dresh1,lMresh1,TMPh1,Gvech1,Ivech1,lIvech1,ResMh1] = fPsim1n(Par,nsamp,Ah1,lh1,Wsp0h1,Psph1,avAadjh1,avAcasteh1);
[ProbMh2,presh2,Dresh2,lMresh2,TMPh2,Gvech2,Ivech2,lIvech2,ResMh2] = fPsim1n(Par,nsamp,Ah2,lh2,Wsp0h2,Psph2,avAadjh2,avAcasteh2);
[Psps1,Psphs1,Wsp0m1,Wsp0hm1] = PR(Wsp0h1,Psph1,Wsp0h2,Psph2);
[ProbMs1,press1,Dress1,lMress1,TMPs1,Gvecs1,Ivecs1,lIvecs1,ResMs1] = fPsim1n(Par,nsamp,Ah1,lh1,Wsp0h1,Psps1,avAadjh1,avAcasteh1);
[ProbMm1,presm1,Dresm1,lMresm1,TMPm1,Gvecm1,Ivecm1,lIvecm1,ResMm1] = fPsim1n(Par,nsamp,Ah1,lh1,Wsp0m1,Psps1,avAadjh1,avAcasteh1);

disp('Pol finished');

iSCe = find(choice == 0 & l==A);
nSCe = length(find(choice == 0 & l==A));
iSUe = find(choice == 0 & l<A);
nSUe = length(find(choice == 0 & l<A));
iLe = find(choice == 1);
nLe = length(find(choice == 1));
iPe = find(choice == 2);
nPe = length(iPe);
iCe = find(choice == 3);
nCe = length(iCe);

Rres.MatPre(1,:)= mean(ProbMe(iSUe,:),1);
Rres.MatPre(2,:)= mean(ProbMe(iSCe,:),1); 
Rres.MatPre(3,:)= mean(ProbMe(iLe,:),1);
Rres.MatPre(4,:)= mean(ProbMe(iPe,:),1);
Rres.MatPre(5,:)= mean(ProbMe(iCe,:),1);

ProbMTe = [sum(ProbMe(:,[1 2]),2) sum(ProbMe(:,[3:5]),2)];
Rres.MatPrTe(1,:)= mean(ProbMTe([iSUe;iSCe],:),1);
Rres.MatPrTe(2,:)= mean(ProbMTe([iLe;iPe;iCe],:),1);

iSCh1 = find(choiceh1 == 0 & lh1==Ah1);
nSCh1 = length(find(choiceh1 == 0 & lh1==Ah1));
iSUh1 = find(choiceh1 == 0 & lh1<Ah1);
nSUh1 = length(find(choiceh1 == 0 & lh1<Ah1));
iLh1 = find(choiceh1 == 1);
nLh1 = length(find(choiceh1 == 1));
iPh1 = find(choiceh1 == 2);
nPh1 = length(iPh1);
iCh1 = find(choiceh1 == 3);
nCh1 = length(iCh1);

Rres.MatPrh1(1,:)= mean(ProbMh1(iSUh1,:),1);
Rres.MatPrh1(2,:)= mean(ProbMh1(iSCh1,:),1); 
Rres.MatPrh1(3,:)= mean(ProbMh1(iLh1,:),1);
Rres.MatPrh1(4,:)= mean(ProbMh1(iPh1,:),1);
Rres.MatPrh1(5,:)= mean(ProbMh1(iCh1,:),1);

ProbMTh1 = [sum(ProbMh1(:,[1 2]),2) sum(ProbMh1(:,[3:5]),2)];
Rres.MatPrTh1(1,:)= mean(ProbMTh1([iSUh1;iSCh1],:),1);
Rres.MatPrTh1(2,:)= mean(ProbMTh1([iLh1;iPh1;iCh1],:),1);


iSCh2 = find(choiceh2 == 0 & lh2==Ah2);
nSCh2 = length(find(choiceh2 == 0 & lh2==Ah2));
iSUh2 = find(choiceh2 == 0 & lh2<Ah2);
nSUh2 = length(find(choiceh2 == 0 & lh2<Ah2));
iLh2 = find(choiceh2 == 1);
nLh2 = length(find(choiceh2 == 1));
iPh2 = find(choiceh2 == 2);
nPh2 = length(iPh2);
iCh2 = find(choiceh2 == 3);
nCh2 = length(iCh2);

Rres.MatPrh2(1,:)= mean(ProbMh2(iSUh2,:),1);
Rres.MatPrh2(2,:)= mean(ProbMh2(iSCh2,:),1); 
Rres.MatPrh2(3,:)= mean(ProbMh2(iLh2,:),1);
Rres.MatPrh2(4,:)= mean(ProbMh2(iPh2,:),1);
Rres.MatPrh2(5,:)= mean(ProbMh2(iCh2,:),1);

ProbMTh2 = [sum(ProbMh2(:,[1 2]),2) sum(ProbMh2(:,[3:5]),2)];
Rres.MatPrTh2(1,:)= mean(ProbMTh2([iSUh2;iSCh2],:),1);
Rres.MatPrTh2(2,:)= mean(ProbMTh2([iLh2;iPh2;iCh2],:),1);

Rres.mld = mld;
Rres.Par = Par;
%Rres.ParM = ParM;
Rres.Ne = ne;

Rres.etae = [mean(ResMe(:,6)) std(ResMe(:,6))];
Rres.etah1 = [mean(ResMh1(:,6)) std(ResMh1(:,6))];
Rres.etah2 = [mean(ResMh2(:,6)) std(ResMh2(:,6))];
Rres.etas1 = [mean(ResMs1(:,6)) std(ResMs1(:,6))];
Rres.etam1 = [mean(ResMm1(:,6)) std(ResMm1(:,6))];

Rres.DPe = [nSUe/ne nSCe/ne nLe/ne nPe/ne nCe/ne]; 
Rres.MPe = prese;

L = l;
L(sort([iLe;iPe;iCe])) = L(sort([iLe;iPe;iCe])) + A(sort([iLe;iPe;iCe]));
Rres.DLe = [mean(log(L)) (var(log(L)))^.5];  
Rres.DLMe = [mean(log(L(iSUe))) mean(log(L(iSCe))) mean(log(L(iLe))) mean(log(L(iPe))) mean(log(L(iCe))) mean(log(L([iSUe;iSCe]))) mean(log(L([iLe;iPe;iCe])))];  

Rres.Lcorre = [corr(L,ResMe(:,4)) corr(L(iSUe),ResMe(iSUe,4)) corr(L(iSCe),ResMe(iSCe,4)) corr(L(iLe),ResMe(iLe,4)) corr(L(iPe),ResMe(iPe,4)) corr(L(iCe),ResMe(iCe,4)) corr(L([iSUe;iSCe]),ResMe([iSUe;iSCe],4)) corr(L([iLe;iPe;iCe]),ResMe([iLe;iPe;iCe],4))];   
Rres.MLe = [mean(ResMe(:,4)) mean(ResMe(:,5))];
Rres.MLMe = lMrese;
Rres.TMPe = TMPe;
Rres.TMPall = TMPe + TMPh1 + TMPh2;
Rres.De = [mean(Drese) median(Drese)];
Rres.Mate = [Gvece Ivece lIvece];
Rres.Matgh1 = [Gvech1 Ivech1 lIvech1];
Rres.Matgh2 = [Gvech2 Ivech2 lIvech2];

Rres.Nh1 = nh1;
Rres.DPh1 = [nSUh1/nh1 nSCh1/nh1 nLh1/nh1 nPh1/nh1 nCh1/nh1]; 

Rres.MPh1 = presh1;
Rres.MPs1 = press1;
Rres.MPm1 = presm1;

Lh1 = lh1;
Lh1(sort([iLh1;iPh1;iCh1])) = Lh1(sort([iLh1;iPh1;iCh1])) + A(sort([iLh1;iPh1;iCh1]));
Rres.DLh1 = [mean(log(Lh1)) (var(log(Lh1)))^.5];  
Rres.DLMh1 = [mean(log(L(iSUh1))) mean(log(L(iSCh1))) mean(log(L(iLh1))) mean(log(L(iPh1))) mean(log(L(iCh1))) mean(log(L([iSUh1;iSCh1]))) mean(log(L([iLh1;iPh1;iCh1])))];  
Rres.Lcorrh1 = [corr(Lh1,ResMh1(:,4)) corr(Lh1(iSUh1),ResMh1(iSUh1,4)) corr(Lh1(iSCh1),ResMh1(iSCh1,4)) corr(Lh1(iLh1),ResMh1(iLh1,4)) corr(Lh1(iPh1),ResMh1(iPh1,4)) corr(Lh1(iCh1),ResMh1(iCh1,4)) corr(Lh1([iSUh1;iSCh1]),ResMh1([iSUh1;iSCh1],4)) corr(Lh1([iLh1;iPh1;iCh1]),ResMh1([iLh1;iPh1;iCh1],4))]; 
Rres.MLh1 = [mean(ResMh1(:,4)) mean(ResMh1(:,5))];
Rres.Dh1 = [mean(Dresh1) median(Dresh1)];

Rres.MLs1 = [mean(ResMs1(:,4)) mean(ResMs1(:,5))];
Rres.Ds1 = [mean(Dress1) median(Dress1)];

Rres.MLm1 = [mean(ResMm1(:,4)) mean(ResMm1(:,5))];
Rres.Dm1 = [mean(Dresm1) median(Dresm1)];

Rres.MLMh1 = lMresh1;
Rres.MLMs1 = lMress1;
Rres.MLMm1 = lMresm1;

Rres.Nh2 = nh2;
Rres.DPh2 = [nSUh2/nh2 nSCh2/nh2 nLh2/nh2 nPh2/nh2 nCh2/nh2]; 

Rres.Mh2 = presh2;

Lh2 = lh2;
Lh2(sort([iLh2;iPh2;iCh2])) = Lh2(sort([iLh2;iPh2;iCh2])) + A(sort([iLh2;iPh2;iCh2]));
Rres.DLh2 = [mean(log(Lh2)) (var(log(Lh2)))^.5];  
Rres.DLMh2 = [mean(log(L(iSUh2))) mean(log(L(iSCh2))) mean(log(L(iLh2))) mean(log(L(iPh2))) mean(log(L(iCh2))) mean(log(L([iSUh2;iSCh2]))) mean(log(L([iLh2;iPh2;iCh2])))];  
Rres.Lcorrh2 = [corr(Lh2,ResMh2(:,4)) corr(Lh2(iSUh2),ResMh2(iSUh2,4)) corr(Lh2(iSCh2),ResMh2(iSCh2,4)) corr(Lh2(iLh2),ResMh2(iLh2,4)) corr(Lh2(iPh2),ResMh2(iPh2,4)) corr(Lh2(iCh2),ResMh2(iCh2,4)) corr(Lh2([iSUh2;iSCh2]),ResMh2([iSUh2;iSCh2],4)) corr(Lh2([iLh2;iPh2;iCh2]),ResMh2([iLh2;iPh2;iCh2],4))];
Rres.MLh2 = [mean(ResMh2(:,4)) mean(ResMh2(:,5))];
Rres.Dh2 = [mean(Dresh2) median(Dresh2)];

Rres.MLMh2 = lMresh2;
Rres.ResMe = ResMe;

eval(['save ',filres]);                 
